/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.biblioteca.util;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

/**
 * Classe para compilao e validao de expresses regulares
 */
public class ExpressaoRegular
{
    /**
     * Compila expresso regular (utilizada para saber se a expresso  vlida)
     * 
     * @param strExpressaoRegular String contendo a expresso
     * 
     * @return boolean Contendo a validao
     */
    public static boolean compilar(String strExpressaoRegular)
    {
        try
        {
            Pattern.compile(strExpressaoRegular);
            return true;
        }
		catch (PatternSyntaxException pse)
		{
		    return false;
		}
    }

    /**
     * Valida um texto dada a expresso regular
     * 
     * @param strExpressaoRegular String contendo a expresso
     * @param strTexto String contendo o texto a ser validado
     * 
     * @return boolean Contendo a validao
     */
    public static boolean validar(String strExpressaoRegular, String strTexto)
    {
        // Declaraes
        Pattern patPattern = null;
        Matcher matMatcher = null;
        
        // Valida a mscara        
        if ("".equals(strExpressaoRegular))
        {
            return true;                        
        }
        patPattern = Pattern.compile(strExpressaoRegular);
        matMatcher = patPattern.matcher(strTexto );
        if (matMatcher.matches())
        {
            return true;
        }
        else
        {
            return false;
        }
    }
}
