/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.hibernate;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.map.CaseInsensitiveMap;
import org.hibernate.transform.BasicTransformerAdapter;

public class AliasToMapResultTransformer extends BasicTransformerAdapter implements Serializable
{
    private static final long serialVersionUID = -3226514300124978087L;

    public static final AliasToMapResultTransformer INSTANCE = new AliasToMapResultTransformer();

    @Override
    public final Object transformTuple(Object[] tuple, String[] aliases)
    {
        Map<String, Object> registro = criarMapa(tuple, aliases);
        Object objeto = transformarRegistro(registro);
        return objeto;
    }

    public Object transformarRegistro(Map<String, Object> registro)
    {
        return registro;
    }

    @SuppressWarnings("rawtypes")
    @Override
    public final List transformList(List list)
    {
        List lista = transformarLista(list);
        return lista;
    }

    @SuppressWarnings("rawtypes")
    public List transformarLista(List lista)
    {
        return lista;
    }

    private Map<String, Object> criarMapa(Object[] tuple, String[] aliases)
    {
        @SuppressWarnings("unchecked")
        Map<String, Object> registro = new CaseInsensitiveMap(tuple.length);
        for (int i = 0; i < tuple.length; i++)
        {
            registro.put(aliases[i], tuple[i]);
        }
        return registro;
    }
}
