/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.hibernate;

public class FacadeDelimitadora extends DelimitadoraSessaoTransacao
{
    @Override
    protected String getAssinaturaOperadorSessaoTransacao(StackTraceElement stackTraceElement)
    {
        String assinatura = stackTraceElement.getClassName() + "." + stackTraceElement.getMethodName();
        if (assinatura.indexOf("Facade.") == -1)
        {
            assinatura = null;
        }
        return assinatura;
    }

    @Override
    protected boolean isDelimitadoraPrimeiraAssinatura()
    {
        // Desconectar sesso ou realizar ou desfazer transao somente na LTIMA chamda (assinatura),
        // pois pode existir o caso de recursividade quando somente a ltima chamada  que deve ser responsvel pela sesso/transao. 
        return false;
    }

    @Override
    protected boolean isClassePreDelimitadora(StackTraceElement stackTraceElement)
    {
        String nomeClasse = stackTraceElement.getClassName();
        return nomeClasse.endsWith("DAO");
    }
}
