/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

/**
 * 
 */
package br.gov.camara.hibernate.interceptor.session;

import org.hibernate.HibernateException;
import org.hibernate.Session;

import br.gov.camara.hibernate.exception.HibernateExceptionCD;

/**
 * @author P_6414
 *
 */
public abstract class SessionInterceptor
{
    /**
     * Executa este mtodo logo aps obter a sesso do Hibernate
     * @param sessao Sesso recuperada do SessionFactory
     * @return retorna a sesso tratada por este mtodo
     * @throws HibernateException
     */
    public Session executarAposObterNovaSessao(Session sessao) throws HibernateExceptionCD
    {
        return sessao;
    }

    /**
     * Executa este mtodo logo antes de fechar a sesso do Hibernate
     * @param sessao Sesso que ser fechada a seguir
     * @return retorna a sesso tratada por este mtodo
     * @throws HibernateException
     */
    public Session executarAntesFecharSessao(Session sessao) throws HibernateExceptionCD
    {
        return sessao;
    }
}
