/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.hibernate.interceptor.session;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Session;

import br.gov.camara.biblioteca.util.ClasseDinamica;
import br.gov.camara.exception.CDException;
import br.gov.camara.hibernate.exception.HibernateExceptionCD;

public class SessionInterceptorManager
{

    public static final String TIPO_INTERCEPTOR_SESSION = "session";

    private List lstInterceptorSession = null;

    public SessionInterceptorManager(List lstNomesInterceptadoresSession)
    {
        if (lstNomesInterceptadoresSession == null || lstNomesInterceptadoresSession.size() < 1)
        {
            throw new RuntimeException("A lista de interceptadores de sesso no pode ser vazia");
        }

        this.lstInterceptorSession = new ArrayList();
        ClasseDinamica classeDinamica = new ClasseDinamica();
        for (int i = 0; i < lstNomesInterceptadoresSession.size(); i++)
        {
            SessionInterceptor sessionInterceptor = null;

            try
            {
                sessionInterceptor = (SessionInterceptor) classeDinamica.obterInstancia((String) lstNomesInterceptadoresSession.get(i));
            }
            catch (CDException cde)
            {
                throw new RuntimeException("Ocorreu o seguinte erro carregando o interceptador de sesso '"
                        + (String) lstNomesInterceptadoresSession.get(i)
                        + "': "
                        + cde.getMessage());
            }

            this.lstInterceptorSession.add(sessionInterceptor);
        }
    }

    // EXECUTAR aps OBTER SESSO
    public Session executarAposObterNovaSessao(Session sessao, String nomeConexao) throws HibernateExceptionCD
    {
        if (this.lstInterceptorSession != null)
        {
            for (int i = 0; i < this.lstInterceptorSession.size(); i++)
            {
                SessionInterceptor sessionInterceptor = (SessionInterceptor) this.lstInterceptorSession.get(i);
                sessao = sessionInterceptor.executarAposObterNovaSessao(sessao);
            }
        }
        return sessao;
    }

    // EXECUTAR antes FECHAR SESSO
    public Session executarAntesFechar(Session sessao, String nomeConexao) throws HibernateExceptionCD
    {
        if (this.lstInterceptorSession != null)
        {
            for (int i = 0; i < this.lstInterceptorSession.size(); i++)
            {
                SessionInterceptor sessionInterceptor = (SessionInterceptor) this.lstInterceptorSession.get(i);
                sessao = sessionInterceptor.executarAntesFecharSessao(sessao);
            }
        }
        return sessao;
    }
}
