/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.autenticacaoperfil.pojo;

import java.util.Calendar;

import br.gov.camara.hibernate.interceptor.InterceptorHistoricoAtualizacao;
import br.gov.camara.hibernate.interceptor.InterceptorUltimaAtualizacao;

public class CriterioAcessoPerfil implements InterceptorUltimaAtualizacao, InterceptorHistoricoAtualizacao
{

    //  Variveis de instncia
    private Integer intIdentificador;
    private PerfilSistema objPerfilSistema;
    private CriterioAcesso objCriterioAcesso;
    private String strValorCriterioAcessoPerfil;
    private String strNomeCriterioAcessoPerfil;
    private Calendar calDataUltimaAtualizacao;
    private String strUsuarioUltimaAtualizacao;
    private String strPreRequisito;

    /**
     * Obtm Data da ltima atualizao do registro
     * 
     * @return Calendar Contendo o dado
     * 
     */
    public Calendar getDataUltimaAtualizacao()
    {
        return calDataUltimaAtualizacao;
    }

    /**
     * Obtm Usurio que realizou a ltima atualizaao do registro
     * 
     * @return UsuarioSistema Contendo o dado
     * 
     */
    public String getUsuarioUltimaAtualizacao()
    {
        return strUsuarioUltimaAtualizacao;
    }

    /**
     * Obtm o pr-requisito
     * 
     * @return String contendo o dado
     * 
     */
    public String getPreRequisito()
    {
        return strPreRequisito;
    }
    
    /**
     * Obtm a chave
     * 
     * @return String identificador do registro 
     * 
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm Nome do critrio
     *  
     * @return String nome do critrio
     * 
     */
    public PerfilSistema getPerfilSistema()
    {
        return objPerfilSistema;
    }

    /**
     * Obtm Classe implementadora
     * 
     * @return nome da classe implementadora 
     * 
     */
    public CriterioAcesso getCriterioAcesso()
    {
        return objCriterioAcesso;
    }

    /**
     * Preenche identificador
     * 
     * @param intIdentificador Com o dado desejado
     * 
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Preenche nome do critrio
     * 
     * @param strNome Com o dado desejado
     * 
     */
    public void setPerfilSistema(PerfilSistema objPerfilSistema)
    {
        this.objPerfilSistema = objPerfilSistema;
    }

    /**
     * Preenche Classe implementadora
     * 
     * @param String Com o dado desejado
     * 
     */
    public void setCriterioAcesso(CriterioAcesso objCriterioAcesso)
    {
        this.objCriterioAcesso = objCriterioAcesso;
    }

    /**
     * @param calDataUltimaAtualizacao Data da ltima atualizao do registro.
     */
    public void setDataUltimaAtualizacao(Calendar calDataUltimaAtualizacao)
    {
        this.calDataUltimaAtualizacao = calDataUltimaAtualizacao;
    }

    /**
     * @param objUsuarioUltimaAtualizacao Usurio que realizou a ltima atualizao do registro.
     */
    public void setUsuarioUltimaAtualizacao(String strUsuarioUltimaAtualizacao)
    {
        this.strUsuarioUltimaAtualizacao = strUsuarioUltimaAtualizacao;
    }

    public String getNomeCriterioAcessoPerfil()
    {
        return strNomeCriterioAcessoPerfil;
    }

    public void setNomeCriterioAcessoPerfil(String strNomeCriterioAcessoPerfil)
    {
        this.strNomeCriterioAcessoPerfil = strNomeCriterioAcessoPerfil;
    }

    public String getValorCriterioAcessoPerfil()
    {
        return strValorCriterioAcessoPerfil;
    }

    public void setValorCriterioAcessoPerfil(String strValorCriterioAcessoPerfil)
    {
        this.strValorCriterioAcessoPerfil = strValorCriterioAcessoPerfil;
    }

    public void setPreRequisito(String strPreRequisito)
    {
        this.strPreRequisito = strPreRequisito;
    }

    public String getChaveEntidade()
    {
        return getCriterioAcesso().toString();
    }
}
