/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.autenticacaoperfil.pojo;

import java.util.Calendar;
import java.util.Date;

import br.gov.camara.hibernate.interceptor.InterceptorHistoricoAtualizacao;
import br.gov.camara.hibernate.interceptor.InterceptorUltimaAtualizacao;

/**
 * POJO para usurio de sistema
 *  
 */

public class UsuarioSistema implements InterceptorUltimaAtualizacao, InterceptorHistoricoAtualizacao
{

    // Variveis de instncia
    private Integer intIdentificador;
    private String strNome;
    private String strLogin;
    private String strSenhaHash;
    private String strExpiracaoSenha;
    private Date datAtualizacaoSenha;
    private Date datValidade;
    private Date datDesligamento;
    private Grupo objGrupo;
    private String strChaveConsulta;
    private Calendar calDataUltimaAtualizacao;
    private String strUsuarioUltimaAtualizacao;

    /**
     * Obtm Data da ltima atualizao do registro
     * 
     * @return Calendar Contendo o dado
     * 
     */
    public Calendar getDataUltimaAtualizacao()
    {
        return this.calDataUltimaAtualizacao;
    }

    /**
     * Obtm Usurio que realizou a ltima atualizaao do registro
     * 
     * @return UsuarioSistema Contendo o dado
     * 
     */
    public String getUsuarioUltimaAtualizacao()
    {
        return this.strUsuarioUltimaAtualizacao;
    }

    /**
     * Obtm identificador
     * 
     * @return Integer Contendo o dado
     * 
     */
    public Integer getIdentificador()
    {
        return this.intIdentificador;
    }

    /**
     * Obtm nome do usurio
     * 
     * @return String Contendo o dado
     * 
     */
    public String getNome()
    {
        return this.strNome;
    }

    /**
     * Obtm login
     * 
     * @return String Contendo o dado
     * 
     */
    public String getLogin()
    {
        return this.strLogin;
    }

    /**
     * Atribui identificador
     *  
     * @param int valor do Identificador
     * 
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Atribui nome do usurio
     *  
     * @param String valor do nome
     * 
     */
    public void setNome(String strNome)
    {
        this.strNome = strNome;
    }

    /**
     * Atribui login
     *  
     * @param String valor do nome
     * 
     */
    public void setLogin(String strLogin)
    {
        this.strLogin = strLogin;
    }

    /**
     * @return Returns the datAtualizacaoSenha.
     */
    public Date getDataAtualizacaoSenha()
    {
        return this.datAtualizacaoSenha;
    }

    /**
     * @param datAtualizacaoSenha The datAtualizacaoSenha to set.
     */
    public void setDataAtualizacaoSenha(Date datAtualizacaoSenha)
    {
        this.datAtualizacaoSenha = datAtualizacaoSenha;
    }

    /**
     * @return Returns the datDesligamento.
     */
    public Date getDataDesligamento()
    {
        return this.datDesligamento;
    }

    /**
     * @param datDesligamento The datDesligamento to set.
     */
    public void setDataDesligamento(Date datDesligamento)
    {
        this.datDesligamento = datDesligamento;
    }

    /**
     * @return Returns the datValidade.
     */
    public Date getDataValidade()
    {
        return this.datValidade;
    }

    /**
     * @param datValidade The datValidade to set.
     */
    public void setDataValidade(Date datValidade)
    {
        this.datValidade = datValidade;
    }

    /**
     * @return Returns the objGrupo.
     */
    public Grupo getGrupo()
    {
        return this.objGrupo;
    }

    /**
     * @param objGrupo The objGrupo to set.
     */
    public void setGrupo(Grupo objGrupo)
    {
        this.objGrupo = objGrupo;
    }

    /**
     * @return Returns the strExpiracaoSenha.
     */
    public String getExpiracaoSenha()
    {
        return this.strExpiracaoSenha;
    }

    /**
     * @param strExpiracaoSenha The strExpiracaoSenha to set.
     */
    public void setExpiracaoSenha(String strExpiracaoSenha)
    {
        this.strExpiracaoSenha = strExpiracaoSenha;
    }

    /**
     * @return Returns the strSenhaHash.
     */
    public String getSenhaHash()
    {
        return this.strSenhaHash;
    }

    /**
     * @param strSenhaHash The strSenhaHash to set.
     */
    public void setSenhaHash(String strSenhaHash)
    {
        this.strSenhaHash = strSenhaHash;
    }

    /**
     * @return Returns the strChaveConsulta.
     */
    public String getChaveConsulta()
    {
        return this.strChaveConsulta;
    }

    /**
     * @param strChaveConsulta The strChaveConsulta to set.
     */
    public void setChaveConsulta(String strChaveConsulta)
    {
        this.strChaveConsulta = strChaveConsulta;
    }

    /**
     * @param calDataUltimaAtualizacao Data da ltima atualizao do registro.
     */
    public void setDataUltimaAtualizacao(Calendar calDataUltimaAtualizacao)
    {
        this.calDataUltimaAtualizacao = calDataUltimaAtualizacao;
    }

    /**
     * @param objUsuarioUltimaAtualizacao Usurio que realizou a ltima atualizao do registro.
     */
    public void setUsuarioUltimaAtualizacao(String strUsuarioUltimaAtualizacao)
    {
        this.strUsuarioUltimaAtualizacao = strUsuarioUltimaAtualizacao;
    }

    public String getChaveEntidade()
    {
        return this.getIdentificador().toString();
    }

    @Override
    public int hashCode()
    {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((intIdentificador == null) ? 0 : intIdentificador.hashCode());
        result = prime * result + ((strLogin == null) ? 0 : strLogin.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        UsuarioSistema other = (UsuarioSistema) obj;
        if (intIdentificador == null)
        {
            if (other.intIdentificador != null)
                return false;
        }
        else if (!intIdentificador.equals(other.intIdentificador))
            return false;
        if (strLogin == null)
        {
            if (other.strLogin != null)
                return false;
        }
        else if (!strLogin.equals(other.strLogin))
            return false;
        return true;
    }

    @Override
    public String toString()
    {
        return "UsuarioSistema [intIdentificador=" + intIdentificador + ", strLogin=" + strLogin + "]";
    }

}
