/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.consultatalento;

import java.util.Date;

import org.joda.time.LocalDate;
import org.joda.time.LocalDateTime;

public class ResultadoConsultaTalento
{
    private int ponto;
    private String nome;
    private int codigoGrupo;
    private String nomeGrupo;
    private String nomeUltimaLotacao;
    private LocalDate dataTerminoUltimaLotacao;
    private LocalDate dataDesligamento;
    private LocalDateTime dataHoraUltimaAtualizacaoCurricular;

    private ResultadoConsultaTalento(int ponto, String nome, int codigoGrupo, String nomeGrupo, String nomeUltimaLotacao, LocalDate dataTerminoUltimaLotacao,
            LocalDate dataDesligamento, LocalDateTime dataHoraUltimaAtualizacaoCurricular)
    {
        this.ponto = ponto;
        this.nome = nome;
        this.codigoGrupo = codigoGrupo;
        this.nomeGrupo = nomeGrupo;
        this.nomeUltimaLotacao = nomeUltimaLotacao;
        this.dataTerminoUltimaLotacao = dataTerminoUltimaLotacao;
        this.dataDesligamento = dataDesligamento;
        this.dataHoraUltimaAtualizacaoCurricular = dataHoraUltimaAtualizacaoCurricular;
    }

    public static ResultadoConsultaTalento com(int ponto, String nome, int codigoGrupo, String nomeGrupo, String nomeUltimaLotacao, LocalDate dataTerminoUltimaLotacao, LocalDate dataDesligamento, LocalDateTime dataHoraUltimaAtualizacaoCurricular)
    {
        return new ResultadoConsultaTalento(ponto, nome, codigoGrupo, nomeGrupo, nomeUltimaLotacao, dataTerminoUltimaLotacao, dataDesligamento, dataHoraUltimaAtualizacaoCurricular);
    }

    public int getPonto()
    {
        return ponto;
    }

    public String getNome()
    {
        return nome;
    }

    public int getCodigoGrupo()
    {
        return codigoGrupo;
    }

    public String getNomeGrupo()
    {
        return nomeGrupo;
    }

    public String getNomeUltimaLotacao()
    {
        return nomeUltimaLotacao;
    }

    public LocalDate getDataTerminoUltimaLotacao()
    {
        return dataTerminoUltimaLotacao;
    }

    public LocalDate getDataDesligamento()
    {
        return dataDesligamento;
    }

    public Date getDataDesligamentoComoData()
    {
        return dataDesligamento == null ? null : dataDesligamento.toDate();
    }

    public LocalDateTime getDataHoraUltimaAtualizacaoCurricular()
    {
        return dataHoraUltimaAtualizacaoCurricular;
    }

    public Date getDataHoraUltimaAtualizacaoCurricularComoData()
    {
        return dataHoraUltimaAtualizacaoCurricular == null ? null : dataHoraUltimaAtualizacaoCurricular.toDate();
    }

}
