/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.demonstracao;

import java.io.FileReader;
import java.sql.Connection;
import java.sql.SQLException;

import org.h2.tools.RunScript;
import org.hibernate.Session;
import org.hibernate.impl.SessionImpl;
import org.hibernate.jdbc.JDBCContext;

import br.gov.camara.hibernate.HibernateUtilCD;
import br.gov.camara.negocio.DAO;
import br.gov.camara.negocio.exception.DAOException;

class BancoDeDadosDeDemonstracaoDAO extends DAO
{
    BancoDeDadosDeDemonstracaoDAO(String nomeConexao)
    {
        super("BancoDeDadosDeDemonstracaoDAO", nomeConexao);
    }

    void executarScript(FileReader arquivo) throws DAOException
    {
        Session sessaoHibernate = HibernateUtilCD.obterSessao(nomeConexao);

        JDBCContext contexto = ((SessionImpl) sessaoHibernate).getJDBCContext();
        Connection conexao = contexto.connection();

        try
        {
            RunScript.execute(conexao, arquivo);
        }
        catch (SQLException e)
        {
            DAOException.dispararExcecao(e);
        }
    }
}
