/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

/**
 * POJO para opo de atributo de talento
 */
public class AtributoTalentoOpcao implements Comparable
{
	// Variveis de instncia
    public Integer intIdentificador;
    public AtributoTalentoOpcao objAtributoTalentoOpcaoPai;
    public AtributoTalento objAtributoTalento;
    public String strDescricao;

    /**
     * Obtm identificador
     * 
     * @return Integer Contendo o dado
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm atributo de talento
     * 
     * @return AtributoTalento Contendo o dado
     */
    public AtributoTalento getAtributoTalento()
    {
        return objAtributoTalento;
    }

    /**
     * Obtm opo pai
     * 
     * @return AtributoTalentoOpcao Contendo o dado
     */
    public AtributoTalentoOpcao getAtributoTalentoOpcaoPai()
    {
        return objAtributoTalentoOpcaoPai;
    }

    /**
     * Obtm descrio
     * 
     * @return String Contendo o dado
     */
    public String getDescricao()
    {
        return strDescricao;
    }

    /**
     * Preenche identificador
     * 
     * @param intIdentificador Com o dado desejado
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Preeche atributo de talento
     * 
     * @param objAtributoTalentoTalento Contendo o dado
     */
    public void setAtributoTalento(AtributoTalento objAtributoTalento)
    {
        this.objAtributoTalento = objAtributoTalento;
    }

    /**
     * Preeche opo pai
     * 
     * @param objAtributoTalentoTalentoOpcaoPai Contendo o dado
     */
    public void setAtributoTalentoOpcaoPai(AtributoTalentoOpcao objAtributoTalentoTalentoOpcaoPai)
    {
        this.objAtributoTalentoOpcaoPai = objAtributoTalentoTalentoOpcaoPai;
    }

    /**
     * Preenche descrio
     * 
     * @param strDescricao Contendo o dado
     */
    public void setDescricao(String strDescricao)
    {
        this.strDescricao = strDescricao;
    }
    
    /**
     * Mtodo necessrio para a comparao e ordenao das strings de descrio desse objetos
     */
    public int compareTo(Object obj)
    {
        int retorno = 0;
        AtributoTalentoOpcao objATO = (AtributoTalentoOpcao)obj;
        
        retorno = this.strDescricao.compareToIgnoreCase(objATO.getDescricao());
                
        return retorno;
    }

}
