/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

/**
 * POJO para valorao de atributo de talento
 */
public class AtributoTalentoValorado
{
	// Variveis de instncia
    private Integer intIdentificador;
    private Talento objTalento; 
    private CategoriaAtributoTalento objCategoriaAtributoTalento; 
    private String strValoracao; 
    private AtributoTalentoOpcao objAtributoTalentoOpcao; 

	/**
	 * Obtm identificador
	 * 
	 * @return Integer Contendo o dado
	 */
	public Integer getIdentificador()
	{
		return intIdentificador;
	}

	/**
	 * Obtm opo de atributo de talento
	 * 
	 * @return AtributoTalentoOpcao Contendo o dado
	 */
	public AtributoTalentoOpcao getAtributoTalentoOpcao()
	{
		return objAtributoTalentoOpcao;
	}

	/**
	 * Obtm categoria/atributo
	 * 
	 * @return CategoriaAtributoTalento Contendo o dado
	 */
	public CategoriaAtributoTalento getCategoriaAtributoTalento()
	{
		return objCategoriaAtributoTalento;
	}

	/**
	 * Obtm talento
	 * 
	 * @return Talento Contendo o dado
	 */
	public Talento getTalento()
	{
		return objTalento;
	}

	/**
	 * Obtm valorao
	 * 
	 * @return String Contendo o dado
	 */
	public String getValoracao()
	{
		return strValoracao;
	}

	/**
	 * Preenche o identificador
	 * 
	 * @param intIdentificador Com o dado desejado
	 */
	public void setIdentificador(Integer intIdentificador)
	{
		this.intIdentificador = intIdentificador;
	}

	/**
	 * Preenche a opo
	 * 
	 * @param objAtributoTalentoOpcao Com o dado desejado
	 */
	public void setAtributoTalentoOpcao(AtributoTalentoOpcao objAtributoTalentoOpcao)
	{
		this.objAtributoTalentoOpcao = objAtributoTalentoOpcao;
	}

	/**
	 * Preenche a categoria/atributo
	 * 
	 * @param objCategoriaAtributoTalento Com o dado desejado
	 */
	public void setCategoriaAtributoTalento(CategoriaAtributoTalento objCategoriaAtributoTalento)
	{
		this.objCategoriaAtributoTalento = objCategoriaAtributoTalento;
	}

	/**
	 * Preenche o talento
	 * 
	 * @param objTalento Com o dado desejado
	 */
	public void setTalento(Talento objTalento)
	{
		this.objTalento = objTalento;
	}

	/**
	 * Preenche valorao
	 * 
	 * @param strValoracao Com o dado desejado
	 */
	public void setValoracao(String strValoracao)
	{
		this.strValoracao = strValoracao;
	}
}