/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

import java.util.Set;

/**
 * POJO para categoria de talento
 */
public class CategoriaTalento
{

    // Variveis de instncia
    private Integer intIdentificador;
    private String strNome;
    private String strDescricao;
    private String strDicaPreenchimento;
    private String strIndicativoUnicidade;
    private Integer intSequencialOrdenacao;
    private Set setGruposCategoriaTalento;

    /**
     * Obtm identificador
     * 
     * @return Integer Contendo o dado
     * 
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm ordenao 
     * 
     * @return Integer Contendo o dado
     * 
     */
    public Integer getSequencialOrdenacao()
    {
        return intSequencialOrdenacao;
    }

    /**
     * Obtm descrio 
     * 
     * @return String Contendo o dado
     * 
     */
    public String getDescricao()
    {
        return strDescricao;
    }

    /**
     * Obtm dica de preenchimento
     * 
     * @return String Contendo o dado
     * 
     */
    public String getDicaPreenchimento()
    {
        return strDicaPreenchimento;
    }

    /**
     * Obtm nome
     * 
     * @return String Contendo o dado
     * 
     */
    public String getNome()
    {
        return strNome;
    }

    /**
     * Obtm indicativo de unicidade (a categoria s pode ser inserida uma vez por servidor)
     * 
     * @return String Contendo o dado
     * 
     */
    public String getIndicativoUnicidade()
    {
        return strIndicativoUnicidade;
    }

    /**
     * Obtm os grupos que podem acessar a categoria
     * 
     * @return Set Contendo o ado
     */
    public Set getGruposCategoriaTalento()
    {
        return setGruposCategoriaTalento;
    }

    /**
     * Preenche identificador
     *  
     * @param intIdentificador Contendo o dado
     * 
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Preenche ordenao
     * 
     * @param Integer Contendo o dado
     * 
     */
    public void setSequencialOrdenacao(Integer intSequencialOrdenacao)
    {
        this.intSequencialOrdenacao = intSequencialOrdenacao;
    }

    /**
     * Preenche descrio
     * 
     * @param String Contendo o dado
     * 
     */
    public void setDescricao(String strDescricao)
    {
        this.strDescricao = strDescricao;
    }

    /**
     * Preenche dica de preenchimento
     * 
     * @param String Contendo o dado
     * 
     */
    public void setDicaPreenchimento(String strDicaPreenchimento)
    {
        this.strDicaPreenchimento = strDicaPreenchimento;
    }

    /**
     * Preenche nome
     * 
     * @param String Contendo o dado
     * 
     */
    public void setNome(String strNome)
    {
        this.strNome = strNome;
    }

    /**
     * Preenche unicidade
     * 
     * @param String Contendo o dado
     * 
     */
    public void setIndicativoUnicidade(String strIndicativoUnicidade)
    {
        this.strIndicativoUnicidade = strIndicativoUnicidade;
    }

    /**
     * Preenche os grupos que podem acessar a categoria
     * 
     * @param Set Contendo o dado
     * 
     */
    public void setGruposCategoriaTalento(Set setGruposCategoriaTalento)
    {
        this.setGruposCategoriaTalento = setGruposCategoriaTalento;
    }

    @Override
    public String toString()
    {
        return "{idCategoriaTalento="
                + intIdentificador
                + ", nome="
                + strNome
                + ", descricao="
                + strDescricao
                + ", dicaPreenchimento="
                + strDicaPreenchimento
                + ", indicativoUnicidade="
                + strIndicativoUnicidade
                + ", sequencialOrdenacao="
                + intSequencialOrdenacao
                + ", gruposCategoriaTalento="
                + setGruposCategoriaTalento
                + "}";
    }

}