/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

import java.util.ArrayList;
import java.util.List;

/**
 * POJO para consulta de talento
 * 
 */
public class ConsultaTalento
{
    private TipoConsultaTalento objTipoConsultaTalento;
    private CriterioConsultaTalento objCriterioConsultaTalento;
    private CategoriaTalento objCategoriaTalento;
    private List lstParametrosConsultaTalento;

    /**
     * Obtm opo de atributo de talento
     * 
     * @return objAtributoTalentoOpcao Contendo o dado
     */
    public List getListaParametrosConsulta()
    {
        return lstParametrosConsultaTalento;
    }

    /**
     * Preenche a opo de atributo de talento
     * 
     * @param AtributoTalentoOpcao Com o dado desejado
     */
    public void addParametroConsulta(CategoriaAtributoTalento categoriaAtributoTalento, AtributoTalentoOpcao atributoTalentoOpcao, String opcaoComplementar)
    {
        if (lstParametrosConsultaTalento == null)
        {
            lstParametrosConsultaTalento = new ArrayList();
        }

        ParametroConsultaTalento parametroConsultaTalento = new ParametroConsultaTalento(categoriaAtributoTalento, atributoTalentoOpcao, opcaoComplementar);
        lstParametrosConsultaTalento.add(parametroConsultaTalento);
    }

    /**
     * Obtm tipo de consulta de talento
     * 
     * @return TipoConsultaTalento Com o dado desejado
     */
    public TipoConsultaTalento getTipoConsultaTalento()
    {
        return objTipoConsultaTalento;
    }

    /**
     * Obtm critrio de consulta de talento
     * 
     * @return CriterioConsultaTalento Com o dado desejado
     */
    public CriterioConsultaTalento getCriterioConsultaTalento()
    {
        return objCriterioConsultaTalento;
    }

    /**
     * Prenche o tipo de consulta de talento
     * 
     * @param objTipoConsultaTalento Contendo o dado
     */
    public void setTipoConsultaTalento(TipoConsultaTalento objTipoConsultaTalento)
    {
        this.objTipoConsultaTalento = objTipoConsultaTalento;
    }

    /**
     * Prenche o critrio de consulta de talento
     * 
     * @param objCriterioConsultaTalento Contendo o dado
     */
    public void setCriterioConsultaTalento(CriterioConsultaTalento objCriterioConsultaTalento)
    {
        this.objCriterioConsultaTalento = objCriterioConsultaTalento;
    }

    /**
     * @return the objCategoriaTalento
     */
    public CategoriaTalento getCategoriaTalento()
    {
        return objCategoriaTalento;
    }

    /**
     * @param objCategoriaTalento the objCategoriaTalento to set
     */
    public void setCategoriaTalento(CategoriaTalento objCategoriaTalento)
    {
        this.objCategoriaTalento = objCategoriaTalento;
    }
}
