/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

import java.util.Set;

/**
 * POJO para grupo (de servidores)
 */
public class FiltroConsulta
{
    
    //  Variveis de instncia
    private Integer intIdentificador;
    private String  strNomeFiltroConsulta;
    private TipoFiltroConsulta objTipoFiltroConsulta;
    private Set     setGrupoCriterioConsulta;
    private Set     setFiltroConsultaUsuario;
    private Set     setFiltroConsultaGrupo;

	/**
	 * Obtm Identificador
	 * 
	 * @return Integer Contendo o dado
	 */
	public Integer getIdentificador() 
	{
		return intIdentificador;
	}
	
	/**
	 * Preenche o Identificador
	 * 
	 * @param Integer Contendo o dado
	 */
	public void setIdentificador(Integer intIdentificador) 
	{
		this.intIdentificador = intIdentificador;
	}
	
	/**
	 * Obtm o tipo de filtro para consulta
	 * 
	 * @return List Contendo o dado
	 */
	public TipoFiltroConsulta getTipoFiltroConsulta() 
	{
		return objTipoFiltroConsulta;
	}
	
	/**
	 * Preenche o tipo de filtro para consulta
	 * 
	 * @param List Contendo o dado
	 */
	public void setTipoFiltroConsulta(TipoFiltroConsulta objTipoFiltroConsulta) 
	{
		this.objTipoFiltroConsulta = objTipoFiltroConsulta;
	}
	
	/**
	 * Obtm os grupos de critrios de consulta
	 * 
	 * @return Set Contendo o dado
	 */
	public Set getGrupoCriterioConsulta() 
	{
		return setGrupoCriterioConsulta;
	}
	
	/**
	 * Obtm os filtros de consulta de usurio
	 * 
	 * @return Set Contendo o dado
	 */
	public Set getFiltroConsultaUsuario() 
	{
		return setFiltroConsultaUsuario;
	}

	/**
	 * Obtm os filtros de consulta de grupo
	 * 
	 * @return Set Contendo o dado
	 */
	public Set getFiltroConsultaGrupo() 
	{
		return setFiltroConsultaGrupo;
	}

	/**
	 * Preenche os grupos de critrios de consulta
	 * 
	 * @param Set Contendo o dado
	 */
	public void setGrupoCriterioConsulta(Set setGrupoCriterioConsulta) 
	{
		this.setGrupoCriterioConsulta = setGrupoCriterioConsulta;
	}

	/**
	 * Preenche os grupos de critrios de consulta
	 * 
	 * @param Set Contendo o dado
	 */
	public void setFiltroConsultaUsuario(Set setFiltroConsultaUsuario) 
	{
		this.setFiltroConsultaUsuario = setFiltroConsultaUsuario;
	}

	/**
	 * Preenche os grupos de critrios de consulta
	 * 
	 * @param Set Contendo o dado
	 */
	public void setFiltroConsultaGrupo(Set setFiltroConsultaGrupo) 
	{
		this.setFiltroConsultaGrupo = setFiltroConsultaGrupo;
	}
	
	
	/**
	 * Obtm o nome do filtro de consulta
	 * 
	 * @return String Contendo o dado
	 */
	public String getNomeFiltroConsulta() 
	{
		return strNomeFiltroConsulta;
	}
	
	/**
	 * Preenche o nome do filtro de consulta
	 * 
	 * @param String Contendo o dado
	 */
	public void setNomeFiltroConsulta(String strNomeFiltroConsulta) 
	{
		this.strNomeFiltroConsulta = strNomeFiltroConsulta;
	}
}
