/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

import java.util.Calendar;

import br.gov.camara.biblioteca.util.DataNova;

/**
 * POJO para histrico de lotaes
 */
public class Lotacao
{

    // Variveis de instncia
    private Integer intIdentificador;
    private String strDescricao;
    private Calendar calDataInicio;
    private Calendar calDataTermino;

    /**
     * Obtm data de inicio
     * 
     * @return Calendar Contendo o dado
     * 
     */
    public Calendar getDataInicio()
    {
        return calDataInicio;
    }

    /**
     * Obtm data de inicio formatada
     * 
     * @return Calendar Contendo o dado
     * 
     */
    public String getDataInicioFormatada()
    {
        return DataNova.format(calDataInicio);
    }

    /**
     * Obtm data de trmino
     * 
     * @return Calendar Contendo o dado
     * 
     */
    public Calendar getDataTermino()
    {
        return calDataTermino;
    }

    /**
     * Obtm data de trmino formatada
     * 
     * @return Calendar Contendo o dado
     * 
     */
    public String getDataTerminoFormatada()
    {
        return DataNova.format(calDataTermino);
    }

    /**
     * Obtm identificador
     * 
     * @return Integer Contendo o dado
     * 
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm descrio
     * 
     * @return String Contendo o dado
     * 
     */
    public String getDescricao()
    {
        return strDescricao;
    }

    /**
     * Preenche data de incio
     * 
     * @param Calendar Com o dado desejado
     * 
     */
    public void setDataInicio(Calendar calDataInicio)
    {
        this.calDataInicio = calDataInicio;
    }

    /**
     * Preenche data de trmino
     * 
     * @param Calendar Como o dado desejado
     * 
     */
    public void setDataTermino(Calendar calDataTermino)
    {
        this.calDataTermino = calDataTermino;
    }

    /**
     * Preenche identificador
     * 
     * @param Integer Com o dado desejado
     * 
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Atribui descrio
     * 
     * @param String valor da descrio
     * 
     */
    public void setDescricao(String strDescricao)
    {
        this.strDescricao = strDescricao;
    }

    @Override
    public String toString()
    {
        return "{idLotacao=" + intIdentificador + ", descricao=" + strDescricao + ", dataInicio=" + calDataInicio + ", dataTermino=" + calDataTermino + "}";
    }

}