/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

import java.util.Calendar;
import java.util.Set;

import br.gov.camara.biblioteca.util.DataNova;
import br.gov.camara.negocio.autenticacaoperfil.pojo.Grupo;

/**
 * POJO para pessoal
 */

public class Pessoa
{

    // Variveis de instncia
    private Integer intIdentificador;
    private String strNome;
    private Calendar calDataNascimento;
    private String strSexo;
    private String strCpf;
    private String strRg;
    private Grupo objGrupo;
    private Set<Lotacao> setLotacoes;

    /**
     * Obtm data de nascimento
     * 
     * @return Calendar Contendo o dado
     *  
     */
    public Calendar getDataNascimento()
    {
        return calDataNascimento;
    }

    /**
     * Obtm data de nascimento formatada
     * 
     * @return Calendar Contendo o dado
     *  
     */
    public String getDataNascimentoFormatada()
    {
        return DataNova.format(calDataNascimento);
    }

    /**
     * Obtm identificador
     * 
     * @return Integer Contendo o dado
     * 
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm histrico de lotaes 
     * 
     * @return Set Contendo o dado
     * 
     */
    public Set<Lotacao> getLotacoes()
    {
        return setLotacoes;
    }

    /**
     * Obtm CPF
     * 
     * @return String Contendo o dado
     * 
     */
    public String getCpf()
    {
        return strCpf;
    }

    /**
     * Obtm nome
     * 
     * @return String Contendo o dado
     * 
     */
    public String getNome()
    {
        return strNome;
    }

    /**
     * Obtm RG
     * 
     * @return String Contendo o dado
     */
    public String getRg()
    {
        return strRg;
    }

    /**
     * Obtm sexo
     * 
     * @return String Contendo o dados
     * 
     */
    public String getSexo()
    {
        return strSexo;
    }

    /**
     * Obtm grupo
     * 
     * @return String Contendo o dado 
     * 
     */
    public Grupo getGrupo()
    {
        return objGrupo;
    }

    /**
     * Obtm data de nascimento
     * 
     * @param Calendar Contendo o dado
     * 
     */
    public void setDataNascimento(Calendar calDataNascimento)
    {
        this.calDataNascimento = calDataNascimento;
    }

    /**
     * Preenche identificador
     * 
     * @param intIdentificador Com o dado desejado
     * 
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Preenche histrico de lotaes do servidor
     * 
     * @param Set Com o dado desejado
     * 
     */
    public void setLotacoes(Set<Lotacao> setLotacoes)
    {
        this.setLotacoes = setLotacoes;
    }

    /**
     * Preenhce CPF
     * 
     * @param String Com o dado desejado
     * 
     */
    public void setCpf(String strCpf)
    {
        this.strCpf = strCpf;
    }

    /**
     * Preenche nome
     * 
     * @param String Com o dado desejado
     */
    public void setNome(String strNome)
    {
        this.strNome = strNome;
    }

    /**
     * Preenhce RG
     * 
     * @param String Com o dado desejado
     * 
     */
    public void setRg(String strRg)
    {
        this.strRg = strRg;
    }

    /**
     * Preenche sexo
     * 
     * @param String Com o dado desejado
     * 
     */
    public void setSexo(String strSexo)
    {
        this.strSexo = strSexo;
    }

    /**
     * Preenche grupo
     * 
     * @param String Com o dado desejado
     * 
     */
    public void setGrupo(Grupo objGrupo)
    {
        this.objGrupo = objGrupo;
    }

    @Override
    public String toString()
    {
        return "{idPessoa="
                + intIdentificador
                + ", nome="
                + strNome
                + ", dataNascimento="
                + calDataNascimento
                + ", sexo="
                + strSexo
                + ", cpf="
                + strCpf
                + ", rg="
                + strRg
                + ", grupo="
                + objGrupo
                + ", lotacoes="
                + setLotacoes
                + "}";
    }

}