/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

/**
 * POJO para tabela de apoio de meta dados
 * 
 */
public class TabelaApoioMM
{
	// Variveis de instncia
    public Integer intIdentificador;
    public String strNomeTabela;
    public TabelaApoioMM objTabelaApoioMestreMM;
    public String strNomeIdentificador;
    public String strNomeDescritor;
    public String strNomeIdentificadorTabelaMestre;

    /**
     * Obtm o identificador
     * 
     * @return Integer Contendo o dado
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm tabela de apoio mestre de meta dados
     * 
     * @return TabelaApoioMM Contendo o dado
     */
    public TabelaApoioMM getTabelaApoioMestreMM()
    {
        return objTabelaApoioMestreMM;
    }

    /**
     * Obtm nome do descritor
     * 
     * @return String Contendo o dado
     */
    public String getNomeDescritor()
    {
        return strNomeDescritor;
    }

    /**
     * Obtm nome do identificador da tabela
     * 
     * @return String Contendo o dado
     */
    public String getNomeIdentificador()
    {
        return strNomeIdentificador;
    }

    /**
     * Obtm nome do identificador da tabela mestre
     * 
     * @return String Contendo o dado
     */
    public String getNomeIdentificadorTabelaMestre()
    {
        return strNomeIdentificadorTabelaMestre;
    }

    /**
     * Obtm nome da tabela
     * 
     * @return String Contendo o dado
     */
    public String getNomeTabela()
    {
        return strNomeTabela;
    }

    /**
     * Preenche identificador
     * 
     * @param intIdentificador Com o dado desejado
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Preenche tabela de apoio mestre de meta dados
     * 
     * @param objTabelaApoioMestreMM Com o dado desejado
     */
    public void setTabelaApoioMestreMM(TabelaApoioMM objTabelaApoioMestreMM)
    {
        this.objTabelaApoioMestreMM = objTabelaApoioMestreMM;
    }

    /**
     * Preenche o nome do descritor
     * 
     * @param strNomeDescritor Com o dado desejado
     */
    public void setNomeDescritor(String strNomeDescritor)
    {
        this.strNomeDescritor = strNomeDescritor;
    }

    /**
     * Preenche o identificador da tabela
     * 
     * @param strNomeIdentificador Com o dado desejado
     */
    public void setNomeIdentificador(String strNomeIdentificador)
    {
        this.strNomeIdentificador = strNomeIdentificador;
    }

    /**
     * Preenche o nome do identificador da tabela mestre
     * 
     * @param strNomeIdentificadorTabelaMestre Com o dado desejado
     */
    public void setNomeIdentificadorTabelaMestre(String strNomeIdentificadorTabelaMestre)
    {
        this.strNomeIdentificadorTabelaMestre = strNomeIdentificadorTabelaMestre;
    }

    /**
     * Preenche o nome da tabela
     * 
     * @param strNomeTabela Com o dado desejado
     */
    public void setNomeTabela(String strNomeTabela)
    {
        this.strNomeTabela = strNomeTabela;
    }

}
