/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.pojo;

import java.util.Calendar;

import br.gov.camara.biblioteca.util.DataNova;

/**
 * POJO para talento
 */
public class Talento
{
    private Integer intIdentificador;
    private CategoriaTalento objCategoriaTalento;
    private Calendar calDataLancamento;
    private Pessoa objPessoa;

    /**
     * Obtm data de lanamento 
     * 
     * @return Calendar Contendo o dado
     */
    public Calendar getDataLancamento()
    {
        return calDataLancamento;
    }

    /**
     * Obtm data de lanamento formatada 
     * 
     * @return Calendar Contendo o dado
     */
    public String getDataLancamentoFormatada()
    {
        return DataNova.format(calDataLancamento);
    }

    /**
     * Obtm identificador
     * 
     * @return Integer Contendo o dado
     */
    public Integer getIdentificador()
    {
        return intIdentificador;
    }

    /**
     * Obtm categoria de talento
     * 
     * @return CategoriaTalento Contendo o dado
     */
    public CategoriaTalento getCategoriaTalento()
    {
        return objCategoriaTalento;
    }

    /**
     * Obtm pessoa a qual pertence o talento
     * 
     * @return Pessoa Contendo o dado
     */
    public Pessoa getPessoa()
    {
        return objPessoa;
    }

    /**
     * Preenche data de lanamento
     * 
     * @param calDataLancamento Com o dado desejado
     */
    public void setDataLancamento(Calendar calDataLancamento)
    {
        this.calDataLancamento = calDataLancamento;
    }

    /**
     * Preenche data de lanamento formatada (apenas para padronizar o bean)
     * 
     * @param calDataLancamento Com o dado desejado
     */
    public void setDataLancamentoFormatada(String strDataLancamento)
    {}

    /**
     * Preeche identificador
     * 
     * @param intIdentificador Com o dado desejado
     */
    public void setIdentificador(Integer intIdentificador)
    {
        this.intIdentificador = intIdentificador;
    }

    /**
     * Preenche categoria de talento
     * 
     * @param objCategoriaTalento Com o dado desejado
     */
    public void setCategoriaTalento(CategoriaTalento objCategoriaTalento)
    {
        this.objCategoriaTalento = objCategoriaTalento;
    }

    /**
     * Preenche a pessoa a qual pertence o talento
     * 
     * @param objPessoa Com o dado desejado
     */
    public void setPessoa(Pessoa objPessoa)
    {
        this.objPessoa = objPessoa;
    }

}
