/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.bancotalentos.util;

import java.util.Date;

import br.gov.camara.biblioteca.util.DataNova;
import br.gov.camara.exception.CDException;

public class DadosIndexacaoManual
{
    private String dataInicio = "";
    private String instancia = "";
    private String loginUsuario = "";
    private String quantidadeProcessada = "";
    private String quantidadeTotal = "";

    public DadosIndexacaoManual()
    {}

    public DadosIndexacaoManual(String dataInicio, String instancia, String loginUsuario, String quantidadeProcessada, String quantidadeTotal)
    {
        setDataInicio(dataInicio);
        setInstancia(instancia);
        setLoginUsuario(loginUsuario);
        setQuantidadeProcessada(quantidadeProcessada);
        setQuantidadeTotal(quantidadeTotal);
    }

    public DadosIndexacaoManual(Date dataInicio, String instancia, String loginUsuario, int quantidadeProcessada, int quantidadeTotal)
    {
        setDataInicio(dataInicio);
        setInstancia(instancia);
        setLoginUsuario(loginUsuario);
        setQuantidadeProcessada(quantidadeProcessada);
        setQuantidadeTotal(quantidadeTotal);
    }

    public String getDataInicio()
    {
        return dataInicio;
    }

    public void setDataInicio(Date dataInicio)
    {
        this.dataInicio = DataNova.formatDataHora(dataInicio);
    }

    public void setDataInicio(String dataInicio)
    {
        this.dataInicio = dataInicio;
    }

    public String getInstancia()
    {
        return instancia;
    }

    public void setInstancia(String instancia)
    {
        this.instancia = (instancia == null ? "" : instancia);
    }

    public String getLoginUsuario()
    {
        return loginUsuario;
    }

    public void setLoginUsuario(String loginUsuario)
    {
        this.loginUsuario = (loginUsuario == null ? "" : loginUsuario);
    }

    public String getQuantidadeProcessada()
    {
        return quantidadeProcessada;
    }

    public void setQuantidadeProcessada(String quantidadeProcessada)
    {
        this.quantidadeProcessada = (quantidadeProcessada == null ? "" : quantidadeProcessada);
    }

    public void setQuantidadeProcessada(int quantidadeProcessada)
    {
        this.quantidadeProcessada = Integer.toString(quantidadeProcessada);
    }

    public String getQuantidadeTotal()
    {
        return quantidadeTotal;
    }

    public void setQuantidadeTotal(String quantidadeTotal)
    {
        this.quantidadeTotal = (quantidadeTotal == null ? "" : quantidadeTotal);
    }

    public void setQuantidadeTotal(int quantidadeTotal)
    {
        this.quantidadeTotal = Integer.toString(quantidadeTotal);
    }

    public boolean emExecucaoManual() throws CDException
    {
        return (dataInicio == null || "".equals(dataInicio)) ? false : true;
    }

    public boolean getEmExecucaoManual() throws CDException
    {
        return emExecucaoManual();
    }

    @Override
    public String toString()
    {
        return "{inicio="
                + dataInicio
                + ", instancia="
                + instancia
                + ", usuario="
                + loginUsuario
                + ", quantidadeProcessada="
                + quantidadeProcessada
                + ", quantidadeTotal="
                + quantidadeTotal
                + "}";
    }

}
