/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.comum.facade;

import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.gov.camara.exception.CDException;
import br.gov.camara.negocio.DAO;
import br.gov.camara.negocio.Facade;
import br.gov.camara.negocio.comum.dao.DataDAO;

/**
 * Facade para a exibio do currculo de determinada pessoa
 * 
 */
public class DataHoraBDFacade extends Facade
{
    // Variveis de instncia
    private static Log log = LogFactory.getLog(DataHoraBDFacade.class.getName());

    private static final String nomeConexaoDataHoraBD = "conexaoDataHoraBD";

    /**
     * Obtm a data e a hora do banco de dados
     * 
     *
     * @throws CDException se ocorrer algum erro relacionado ao negcio
     * 
     */
    public static Date obterTimeStampBD() throws CDException
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        DataDAO dataBD = new DataDAO(nomeConexaoDataHoraBD);
        Date objTimeStamp = null;

        try
        {
            DAO.iniciarTransacao(nomeConexaoDataHoraBD);
            objTimeStamp = dataBD.obterTimeStamp();
            DAO.realizarTransacao(nomeConexaoDataHoraBD);
        }
        catch (Exception daoe)
        {
            DAO.desfazerTransacao(nomeConexaoDataHoraBD);
            throw new CDException(daoe);
        }
        finally
        {
            DAO.desconectar(nomeConexaoDataHoraBD);
        }

        return objTimeStamp;
    }
}
