/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.comum.facade;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.gov.camara.exception.CDException;
import br.gov.camara.negocio.DAO;
import br.gov.camara.negocio.Facade;
import br.gov.camara.negocio.comum.dao.TipoHTMLDAO;
import br.gov.camara.negocio.exception.DAOException;

public class TipoHTMLFacade extends Facade
{
    private static Log log = LogFactory.getLog(TipoHTMLFacade.class.getName());

    public TipoHTMLFacade(String nomeConexao)
    {
        super(nomeConexao);
    }

    /**
     * Realiza busca de acordo com a chave informada
     *
     * @param TipoHTMLFacade Objetivo de chave de pesquisa
     * @return Object objeto que representa a chave da consulta
     *  
     * @throws CDException Se ocorrer algum erro relacionado com o acesso a banco de dados
     * 
     */
    public Object obterPelaChave(Object objPOJO) throws CDException
    {
        Object objRetorno = null;
        try
        {
            // Instancia DAO/Bean
            TipoHTMLDAO objTipoHTMLDAO = new TipoHTMLDAO(obterNomeConexao());
            objRetorno = objTipoHTMLDAO.obterPelaChave(objPOJO);
        }
        catch (DAOException daoEx)
        {
            throw daoEx;
        }
        finally
        {
            DAO.desconectar(obterNomeConexao());
        }
        return objRetorno;
    }

    /**
     * Realiza busca de todos os dados 
     *
     * @return List objeto que contm todos os dados da tabela
     *  
     * @throws CDException Se ocorrer algum erro relacionado com o acesso a banco de dados
     * 
     */
    public List obterTodos() throws CDException
    {
        List lstRetorno = null;
        try
        {
            // Instancia DAO/Bean
            TipoHTMLDAO objTipoHTMLDAO = new TipoHTMLDAO(obterNomeConexao());
            lstRetorno = objTipoHTMLDAO.obterTodos();
        }
        catch (DAOException daoEx)
        {
            throw daoEx;
        }
        finally
        {
            DAO.desconectar(obterNomeConexao());
        }
        return lstRetorno;
    }

}
