/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.exception;

import br.gov.camara.exception.CDException;

/**
 * Classe para tratamento de excees em DAOs
 */
public class DAOException extends CDException
{
    /**
     * 
     */
    private static final long serialVersionUID = 5794949280517716027L;

    /**
     * Cria um novo objeto DAOException
     */
    public DAOException()
    {
        super(ERRO_INESPERADO);
    }

    /**
     * Cria um novo objeto DAOException
     * 
     * @param strMensagem Mensagem a ser utilizada no caso da ocorrncia de uma exceo
     */
    public DAOException(String strMensagem)
    {
        super(strMensagem);
    }

    /**
     * Cria um novo objeto DAOException
     * 
     * @param cause Causa da exceo
     */
    public DAOException(Throwable cause)
    {
        super(getMensagem(cause), cause, MensagemErroBD.obterMensagem(cause));
    }

    /**
     * Cria um novo objeto DAOException
     * 
     * @param strMensagem Mensagem a ser utilizada no caso da ocorrncia de uma exceo
     * @param cause Causa da exceo
     */
    public DAOException(String strMensagem, Throwable cause)
    {
        super(strMensagem, cause, MensagemErroBD.obterMensagem(cause));
    }

    /**
     * Cria um novo objeto DAOException
     * 
     * @param dialeto Dialeto a ser tratado
     * @param sqle SQLException gerada pela conexo
     */
    public DAOException(String strMensagem, Throwable excecao, String nomeClasseDialeto)
    {
        super(strMensagem, excecao, MensagemErroBD.obterMensagem(excecao, nomeClasseDialeto));
    }

    /**
     * Cria um novo objeto DAOException
     * 
     * @param dialeto Dialeto a ser tratado
     * @param sqle SQLException gerada pela conexo
     */
    public DAOException(Throwable excecao, String nomeClasseDialeto)
    {
        super(excecao, MensagemErroBD.obterMensagem(excecao, nomeClasseDialeto));
    }

    public static void dispararExcecao(Throwable e, String nomeClasseDialeto) throws DAOException
    {
        if (e instanceof DAOException)
        {
            throw (DAOException) e;
        }
        else
        {
            throw new DAOException(e, nomeClasseDialeto);
        }
    }

    public static void dispararExcecao(Throwable e) throws DAOException
    {
        if (e instanceof DAOException)
        {
            throw (DAOException) e;
        }
        else
        {
            throw new DAOException(e);
        }
    }

    public static void dispararExcecao(String mensagem) throws DAOException
    {
        throw new DAOException(mensagem);
    }

}
