/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.negocio.util;

import java.util.List;

import br.gov.camara.exception.CDException;

/**
 * Interface para permitir consultas genricas para servios
 */

public interface ConsultaComum
{
    /**
     * Define o mtodo utilizado para efetuar consultas genricas
     * 
     * @param objConsulta Objeto contendo a formatao da consulta
     * @param intNumeroPagina Contendo o nmero da pgina a ser exibida
     * @param intMaximoPagina Contendo o total mximo de registros a serem exibidos por pgina
     * 
     * @return List Contendo os POJOs com o resultado da consulta 
     */ 
    public List consultar(Consulta objConsulta, int intNumeroPagina, int intMaximoPagina) throws CDException;

    /**
     * Define o mtodo utilizado para contar os registros daconsulta
     * 
     * @param objConsulta Objeto contendo a formatao da consulta
     * 
     * @return int Contendo o total de registros 
     */ 
    public int obterTotalRegistros(Consulta objConsulta) throws CDException;    
}
