/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

/*
 * Created on 29/03/2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.gov.camara.seguranca;

import br.gov.camara.seguranca.exception.SegurancaException;

/**
 * @author P_6414
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public interface UnidadeAutenticadora
{

    public UsuarioAutenticado autenticarUsuario(String strLoginUsuario, String strSenhaUsuario) throws SegurancaException;

    /**
     * Servico de alteraao de senha de usurio.
     *
     * @param strSenhaAtual : Login do usurio.
     * @param strNovaSenha : Senha do usurio.
     *
     * @return : True, se a rotina encerrou-se normalmente e a senha foi alterada.
     *
     * @throws SegurancaException : Mensagem de erro, caso tenha havido problemas na alterao da senha.
     */
    public boolean alterarSenhaUsuario(UsuarioAutenticado usuarioAutenticado, String strSenhaAtual, String strNovaSenha) throws SegurancaException;

    /**
     * Servico de validao de senha de usurio.
     *
     * @param usuarioAutenticao : Usurio que j est autenticado.
     * @param strNovaSenha : Senha do usurio.
     *
     * @return : True, se a senha do usurio autenticado est correta.
     *
     * @throws SegurancaException : Mensagem de erro, caso tenha havido problemas na validao da senha.
     */
    public boolean validarSenhaUsuario(UsuarioAutenticado usuarioAutenticado, String strSenhaAtual) throws SegurancaException;

    /**
     * Servico que valida se a autenticao do usurio ainda  vlida.
     *
     * @param UsuarioAutenticado autenticao do usurio que deve ser validada
     *
     * @return : True, se a rotina encerrou-se normalmente e a autenticao do usurio  vlida.
     *
     * @throws SegurancaException : Mensagem de erro, caso tenha havido problemas na validao.
     */
    public boolean validarAutenticacao(UsuarioAutenticado usuarioAutenticado) throws SegurancaException;

    /**
     * Servico que limpa a autenticao de um usurio (logoff).
     *
     * @param UsuarioAutenticado autenticao do usurio que deve ser limpada
     *
     * @return : True, se a rotina encerrou-se normalmente e o usurio no est mais autenticado.
     *
     * @throws SegurancaException : Mensagem de erro, caso tenha havido problemas na validao.
     */
    public boolean limparAutenticacao(UsuarioAutenticado usuarioAutenticado) throws SegurancaException;

}
