package br.gov.camara.servlet.util;

import javax.servlet.ServletContext;
import javax.servlet.ServletRequest;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.PageContext;

public class ServletUtil
{
    public static Object findAttribute(String chave, PageContext pageContext)
    {
        Object atributoRecuperado = pageContext.getAttribute(chave);
        if (atributoRecuperado == null)
        {
            ServletRequest request = pageContext.getRequest();
            if (request != null)
            {
                atributoRecuperado = request.getAttribute(chave);
                if (atributoRecuperado == null)
                {
                    HttpSession session = pageContext.getSession();
                    if (session == null)
                    {
                        // Mtodo alternativo caso tenha sido especificado no JSP para criar uma sesso (session = false)
                        try
                        {
                            session = ((HttpServletRequest) pageContext.getRequest()).getSession(false);
                        }
                        catch (Exception e)
                        {
                            // Pacincia... Deve ser de ClassCastException, mas qualquer que seja, ignoraremos
                        }
                    }
                    if (session != null)
                    {
                        atributoRecuperado = session.getAttribute(chave);
                    }

                    if (atributoRecuperado == null)
                    {
                        ServletContext context = pageContext.getServletContext();
                        if (context != null)
                        {
                            atributoRecuperado = context.getAttribute(chave);
                        }
                    }
                }
            }
        }

        return atributoRecuperado;
    }
}
