/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.util.actionplugin.plugin;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import be.ff.gui.web.struts.action.ActionPlugInChain;
import be.ff.gui.web.struts.action.ActionPlugInException;
import br.gov.camara.seguranca.SegurancaWeb;
import br.gov.camara.seguranca.exception.SegurancaException;
import br.gov.camara.util.actionplugin.ActionPluginUtil;
import br.gov.camara.util.actionplugin.plugin.BaseActionPlugIn;

/**
 * DOCUMENTAR!
 */
public class SegurancaActionPlugIn extends BaseActionPlugIn
{
    /**
    * Logger for this class
    */
    private static final Log log = LogFactory.getLog(SegurancaActionPlugIn.class.getName());

    // "A conexo expirou. Autentique-se novamente.";
    private static final String CHAVE_SESSAO_INVALIDA = "sigesp.comum.erro.seguranca.sessao.invalida";
    // "A conexo expirou. Autentique-se novamente.";
    private static final String CHAVE_SESSAO_EXPIRADA = "sigesp.comum.erro.seguranca.sessao.expirada";
    // "Autentique-se primeiro.";
    private static final String CHAVE_USUARIO_NAO_AUTENTICADO = "sigesp.comum.erro.seguranca.usuario.naoautenticado";
    // "Acesso no autorizado.";
    private static final String CHAVE_USUARIO_NAO_AUTORIZADO = "sigesp.comum.erro.seguranca.usuario.naoautorizado";
    // "Autenticao invlida.";
    private static final String CHAVE_AUTENTICACAO_INVALIDA = "sigesp.comum.erro.seguranca.autenticacao.invalida";
    // "A senha expirou. Ela deve ser alterada.";
    private static final String CHAVE_SENHA_EXPIRADA_ALTERAR = "sigesp.comum.erro.seguranca.senha.alterar";

    /**
     * DOCUMENTAR!
     *
     * @param mapping DOCUMENTAR!
     * @param form DOCUMENTAR!
     * @param request DOCUMENTAR!
     * @param response DOCUMENTAR!
     * @param chain DOCUMENTAR!
     *
     * @return DOCUMENTAR!
     *
     * @throws ActionPlugInException DOCUMENTAR!
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response, ActionPlugInChain chain) throws ActionPlugInException
    {

        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo 'execute' - URL='" + ActionPluginUtil.getRequestURL(request) + "'");
        }

        // Recuperar a sesso atual
        HttpSession session = request.getSession(false);
        String strMensagem = null;

        ActionMessages erros = (ActionMessages) request.getAttribute(Globals.ERROR_KEY);

        if (erros == null)
        {
            if (log.isDebugEnabled())
            {
                log.debug("Criando um novo ActionErrors");
            }
            erros = new ActionErrors();
        }
        else
        {
            if (log.isDebugEnabled())
            {
                log.debug("Recuperando o ActionErrors do request");
            }
        }

        // A sesso  vlida ?
        if (session == null)
        {
            session = request.getSession(true);

            // A sesso no  vlida
            strMensagem = obterMensagemRecursoComum(request, CHAVE_SESSAO_INVALIDA);
            if (strMensagem != null)
            {
                erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", strMensagem));
                registraErroRequest(request, erros);
            }

            if (log.isInfoEnabled())
            {
                log.info("Sesso invlida - encaminhando para logon");
            }
            return mapping.findForward("encaminharLogon");
        }

        // Obter dados da segurana
        SegurancaWeb segurancaWeb = SegurancaWeb.obterSegurancaWeb(session);

        // Os dados da segurana esto registrados na session HTTP e tem um usurio logado ?
        if (segurancaWeb == null || !segurancaWeb.temUsuarioLogado(session))
        {
            // No existe registro da segurana ou no existe usurio logado

            // Registrar a mensagem correspondente no request
            if (session.isNew())
            {
                strMensagem = obterMensagemRecursoComum(request, CHAVE_SESSAO_EXPIRADA);
                if (log.isDebugEnabled())
                {
                    log.debug("Sesso vlida e  nova, mas nenhum usurio autenticado. Encaminhando para logon.");
                }
                if (strMensagem != null)
                {
                    erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", strMensagem));
                    registraErroRequest(request, erros);
                }
            }
            else
            {
                strMensagem = obterMensagemRecursoComum(request, CHAVE_USUARIO_NAO_AUTENTICADO);
                if (log.isDebugEnabled())
                {
                    log.debug("Sesso vlida e NO  nova, mas nenhum usurio autenticado. Encaminhando para logon.");
                }
                if (strMensagem != null)
                {
                    erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", strMensagem));
                    registraErroRequest(request, erros);
                }
            }

            // Encaminhar para logon
            if (log.isInfoEnabled())
            {
                log.info("No existe registro da segurana ou no existe usurio logado - encaminhando para logon");
            }
            return mapping.findForward("encaminharLogon");
        }

        // A autenticao  vlida ?
        boolean blnAutenticacaoValida = false;

        try
        {
            blnAutenticacaoValida = segurancaWeb.obterUnidadeAutenticadora().validarAutenticacao(segurancaWeb.obterUsuarioAutenticado());
        }
        catch (SegurancaException se)
        {
            // A autenticacao no  vlida
            strMensagem = se.getMessage();
        }

        if (!blnAutenticacaoValida)
        {
            if (log.isDebugEnabled())
            {
                log.debug("A autenticao no  vlida: " + strMensagem);
            }

            if (strMensagem.indexOf("senha") < 0)
            {
                strMensagem = obterMensagemRecursoComum(request, CHAVE_AUTENTICACAO_INVALIDA);
            }
            else
            {
                strMensagem = obterMensagemRecursoComum(request, CHAVE_SENHA_EXPIRADA_ALTERAR);
            }

            if (strMensagem != null)
            {
                erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", strMensagem));
                registraErroRequest(request, erros);
            }

            // Encaminhar para logon
            if (log.isInfoEnabled())
            {
                log.info("A autenticao no  vlida - encaminhando para logon");
            }
            return mapping.findForward("encaminharLogon");
        }

        // Verifica se o usurio tem autorizao para acessar a URL em questo

        boolean blnTemAutorizacao = false;
        String strObjetoControlado = "";

        strObjetoControlado = ActionPluginUtil.getActionPath(request);

        try
        {
            blnTemAutorizacao = segurancaWeb.obterPermissao().temAutorizacaoFuncionalidade(segurancaWeb.obterUsuarioAutenticado(), strObjetoControlado);
        }
        catch (SegurancaException ue)
        {
            if (log.isErrorEnabled())
            {
                log.error("Erro inesperado ao tentar validar a autorizao deste usurio: " + ue.getMessage());
            }
        }

        if (!blnTemAutorizacao)
        {
            strMensagem = obterMensagemRecursoComum(request, CHAVE_USUARIO_NAO_AUTORIZADO);
            if (log.isInfoEnabled())
            {
                log.info("Usurio SEM permisso: " + strObjetoControlado);
            }
            if (strMensagem != null)
            {
                erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", strMensagem));
                registraErroRequest(request, erros);
            }

            return mapping.findForward("encaminharUsuarioNaoAutorizado");
        }

        if (log.isInfoEnabled())
        {
            log.info("Usurio com permisso: " + strObjetoControlado);
        }

        return chain.execute(mapping, form, request, response);

    }
}
