/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.util.locale;

import java.util.Locale;
import java.util.Random;
import java.util.TimeZone;

import javax.servlet.ServletException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.action.PlugIn;
import org.apache.struts.config.ModuleConfig;

/**
 * Plugin para a configurao do locale
 */
public class LocalePlugIn implements PlugIn
{
    // Inicializa o log
    private static Log log = LogFactory.getLog(LocalePlugIn.class.getName());
    private String strLinguagem = "pt";
    private String strPais = "BR";
    private String strTimeZoneID = "America/Sao_Paulo";

    // Implementao mtodo init
    public void init(ActionServlet servlet, ModuleConfig moduleConfig) throws ServletException
    {
        if (log.isDebugEnabled())
        {
            log.debug("Inicializando o plug-in do Locale...");
        }

        Locale.setDefault(new Locale(this.strLinguagem, this.strPais));
        TimeZone.setDefault(TimeZone.getTimeZone(this.strTimeZoneID));

        // Atribui o ID para a instncia deste servidor de aplicao
        if (servlet.getServletContext().getAttribute("IdInstanciaServidorAplicacao") == null)
        {
            // note a single Random object is reused here
            servlet.getServletContext().setAttribute("IdInstanciaServidorAplicacao", Integer.toString((new Random()).nextInt()));
        }
    }

    // Implementao do mtodo destroy
    public void destroy()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Finalizando o plug-in do Locale...");
        }
    }

    public String getLinguagem()
    {
        return this.strLinguagem;
    }

    public String getPais()
    {
        return this.strPais;
    }

    public void setLinguagem(String strLinguagem)
    {
        this.strLinguagem = strLinguagem;
    }

    public void setPais(String strPais)
    {
        this.strPais = strPais;
    }

    public String getTimeZoneID()
    {
        return this.strTimeZoneID;
    }

    public void setTimeZoneID(String strTimeZoneID)
    {
        this.strTimeZoneID = strTimeZoneID;
    }

}
