/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.util.relatorio;

import br.gov.camara.util.relatorio.exception.RelatorioException;
import br.gov.camara.util.relatorio.jasper.RelatorioJasper;

/**
 * Fbrica de relatrios
 *
 */
public class RelatorioFactory
{
    /**
     * Cria novo relatrio Jasper
     * 
     * @param strLocalizacao String contendo a localizao do relatrio a ser criado
     * @param strRelatorio String contendo o relatrio a ser criado
     * 
     * @return Relatorio Contendo a instncia do objeto requerido
     */
    public static Relatorio obterJasper(String strLocalizacao, String strRelatorio) throws RelatorioException
    {
        return new RelatorioJasper(strLocalizacao, strRelatorio, false);
    }

    /**
     * 
     * @param strLocalizacao
     * @param strRelatorio
     * @param lerArquivoConfiguracao
     * @return
     * @throws RelatorioException
     * @deprecated
     */
    public static Relatorio obterJasper(String strLocalizacao, String strRelatorio, boolean lerArquivoConfiguracao) throws RelatorioException
    {
        // return new RelatorioJasper(strLocalizacao, strRelatorio, lerArquivoConfiguracao); 
        return new RelatorioJasper(strLocalizacao, strRelatorio, false);
    }
}
