/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.util.strutsmenu;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import net.sf.navigator.displayer.MenuDisplayerMapping;
import net.sf.navigator.menu.MenuPlugIn;
import net.sf.navigator.menu.MenuRepository;
import net.sf.navigator.util.LoadableResourceException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.config.ModuleConfig;

public class MenuPlugInCD extends MenuPlugIn
{
    // ~ Instance fields
    // ========================================================

    /**
     * The <code>Log</code> instance for this class.
     */
    private static Log log = LogFactory.getLog(MenuPlugInCD.class.getName());

    private MenuRepository repository;

    private String menuConfig = "/WEB-INF/menu-config.xml";

    private HttpServlet servlet;

    // ~ Methods
    // ================================================================

    public String getMenuConfig()
    {
        return menuConfig;
    }

    public void setMenuConfig(String menuConfig)
    {
        this.menuConfig = menuConfig;
    }

    public void init(ActionServlet servlet, ModuleConfig config) throws ServletException
    {
        if (log.isDebugEnabled())
        {
            log.debug("Starting struts-menu initialization");
        }

        this.servlet = servlet;

        // Alterao por LLD para permitir trabalhar com mdulos
        repository = (MenuRepository) servlet.getServletContext().getAttribute(MenuRepository.MENU_REPOSITORY_KEY);
        if (repository == null)
        {
            repository = new MenuRepository();
            if (log.isDebugEnabled())
            {
                log.debug("Criando um novo repositrio para os menus.");
            }
        }
        // repository = new MenuRepository();
        // Fim da Alterao por LLD

        // Alterao em 2006-02-06 por LLD para permitir a especificao 
        // de mais de um arquivo de menu no struts-config
        String[] arrMenuConfig = menuConfig.split(",");
        int contador = 0;
        while (contador < arrMenuConfig.length)
        {
            repository.setLoadParam(arrMenuConfig[contador].trim());
            repository.setServletContext(servlet.getServletContext());
            try
            {
                repository.load();
            }
            catch (LoadableResourceException lre)
            {
                throw new ServletException("Failure initializing struts-menu: " + lre.getMessage());
            }
            contador++;
        }

        if (arrMenuConfig.length > 0)
        {
            // Utilizar o CoolMenu3 para o "SigespCoolMenu"
            MenuDisplayerMapping sigespDisplayer = new MenuDisplayerMapping();
            sigespDisplayer.setName("SigespCoolMenu");
            sigespDisplayer.setType("br.gov.camara.util.strutsmenu.ExtendedCoolMenuDisplayer");

            repository.addMenuDisplayerMapping(sigespDisplayer);
        }

        servlet.getServletContext().setAttribute(MenuRepository.MENU_REPOSITORY_KEY, repository);

        if (log.isDebugEnabled())
        {
            log.debug("struts-menu initialization successful");
        }
    }

    public void destroy()
    {
        repository = null;
        servlet.getServletContext().removeAttribute(MenuRepository.MENU_REPOSITORY_KEY);
        menuConfig = null;
        servlet = null;
    }
}
