/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.visao.bancotalentosapoio.sequencia;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.util.MessageResources;

import br.gov.camara.exception.CDException;
import br.gov.camara.negocio.bancotalentos.facade.CategoriaAtributoTalentoFacade;
import br.gov.camara.negocio.bancotalentos.pojo.AtributoTalento;
import br.gov.camara.negocio.bancotalentos.pojo.CategoriaAtributoTalento;
import br.gov.camara.negocio.bancotalentos.pojo.CategoriaTalento;
import br.gov.camara.negocio.bancotalentos.util.ConstantesBancoTalentos;
import br.gov.camara.util.displaytag.DisplaytagUtil;
import br.gov.camara.visao.bancotalentosapoio.form.DetalheCategoriaAtributoTalentoForm;
import br.gov.camara.visao.bancotalentosapoio.form.OrdenacaoCategoriaAtributoTalentoForm;
import sigesp.comum.util.struts.SigespSequencia;
import sigesp.comum.util.struts.actions.ActionMessagesUtil;

/**
 * Sequencia CategoriaAtributoTalentoSequencia
 */

public final class CategoriaAtributoTalentoSequencia extends SigespSequencia
{
    // Inicializa o log

    private static Log log = LogFactory.getLog(CategoriaAtributoTalentoSequencia.class.getName());

    /**
     * Metodo construtor
     *
     * @param mapping Mapeamento executado
     * @param form Formulário associado (quando houver)
     * @param request Request
     * @param response Response
     * @param erros Colecao de erros que já ocorreram
     * @param mensagens Colecao de mensagens a serem exibidas
     * @param CategoriaAtributoTalentoAction Classe Action associada
     */

    public CategoriaAtributoTalentoSequencia(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response,
            ActionMessages erros, ActionMessages mensagens, Action action, Map mapRecursos)
    {
        this.mapping = mapping;
        this.form = form;
        this.request = request;
        this.response = response;
        this.errosRequest = erros;
        this.action = action;
        this.mensagensRequest = mensagens;
        this.arlMensagens = new ArrayList();
        this.mapRecursos = mapRecursos;

        this.erros = new ActionMessages();
        this.mensagens = new ActionMessages();
    }

    // Metodos chamados

    /**
     * Metodo categoriaAtributoTalentoEfetuarAlteracao
     */

    public ArrayList categoriaAtributoTalentoEfetuarAlteracao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        // Obtm o form
        DetalheCategoriaAtributoTalentoForm detalheCategoriaAtributoTalentoForm = (DetalheCategoriaAtributoTalentoForm) form;

        // Obtm objeto com a categoria de talento relacionada
        CategoriaTalento objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        // Instacia novo POJO
        CategoriaAtributoTalento objCategoriaAtributoTalento;

        try
        {
            // Busca categoria/atributo de talento para carregar o sequencial de ordenao
            objCategoriaAtributoTalento = objCategoriaAtributoTalentoFacade.obterPelaChaveComAtributoTalentoECategoriaTalento(detalheCategoriaAtributoTalentoForm.getIdentificador());

            // Altera dados
            objCategoriaAtributoTalento.setCategoriaTalento(objCategoriaTalento);
            if (detalheCategoriaAtributoTalentoForm.getAtributoTalento() != null && !"".equals(detalheCategoriaAtributoTalentoForm.getAtributoTalento()))
            {
                AtributoTalento objAtributoTalento = new AtributoTalento();
                objAtributoTalento.setIdentificador(Integer.valueOf(detalheCategoriaAtributoTalentoForm.getAtributoTalento()));
                objCategoriaAtributoTalento.setAtributoTalento(objAtributoTalento);
            }
            objCategoriaAtributoTalento.setIndicativoObrigatoriedade((detalheCategoriaAtributoTalentoForm.getIndicativoObrigatoriedade() ? "S" : "N"));
            objCategoriaAtributoTalento.setFormacaoDescricao((detalheCategoriaAtributoTalentoForm.getFormacaoDescricao() ? "S" : "N"));
            objCategoriaAtributoTalento.setDicaPreenchimento(detalheCategoriaAtributoTalentoForm.getDicaPreenchimento());
            objCategoriaAtributoTalento.setApelido(detalheCategoriaAtributoTalentoForm.getApelido());
            objCategoriaAtributoTalentoFacade.alterar(objCategoriaAtributoTalento);

            // Mensagem
            mensagens.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.mensagem.generica", ((MessageResources) mapRecursos.get("comum")).getMessage("sigesp.comum.interface.mensagem.alteracao.realizada")));
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }

        // Marca encadeamento
        request.setAttribute("blnEncadeamento", new Boolean(true));

        // Mensagens        
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo categoriaAtributoTalentoEfetuarExclusao
     */

    public ArrayList categoriaAtributoTalentoEfetuarExclusao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        // Obtm valor de confirmao, para realizar o controle da excluso 
        // (se aparece msg de confirmao pra atributos valorados)
        String strConfirma = (String) session.getAttribute("strConfirma");
        session.removeAttribute("strConfirma");

        // Obtm o form
        DetalheCategoriaAtributoTalentoForm detalheCategoriaAtributoTalentoForm = (DetalheCategoriaAtributoTalentoForm) form;

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        // Instacia novo POJO
        CategoriaAtributoTalento objCategoriaAtributoTalento = new CategoriaAtributoTalento();

        // Obtm chave para preparao de excluso
        String strChave = request.getParameter("chave");

        try
        {
            // Exclui dados
            objCategoriaAtributoTalento.setIdentificador(Integer.valueOf(strChave));
            objCategoriaAtributoTalentoFacade.excluir(objCategoriaAtributoTalento, strConfirma);

            // Mensagem
            mensagens.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.mensagem.generica", ((MessageResources) mapRecursos.get("comum")).getMessage("sigesp.comum.interface.mensagem.exclusao.realizada")));
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }
            // Verifica se a mensagem  de confirmao de excluso
            if (cde.obterMensagem().indexOf("Confirma excluso?") > 0)
            {
                session.setAttribute("strConfirma", cde.obterMensagem());
                erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", "Confirme a excluso!"));
            }
            else
            {
                erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
            }
        }

        // Marca encadeamento
        request.setAttribute("blnEncadeamento", new Boolean(true));

        // Mensagens        
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo categoriaAtributoTalentoEfetuarOrdenacao
     */

    public ArrayList categoriaAtributoTalentoEfetuarOrdenacao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm o form
        OrdenacaoCategoriaAtributoTalentoForm ordenacaoCategoriaAtributoTalentoForm = (OrdenacaoCategoriaAtributoTalentoForm) form;

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        try
        {
            // Croa lista para ordenao
            List lstOrdenacao = new ArrayList();

            // Itera categorias/atributos de talento obtidas do form
            String strOrdenacao[] = ordenacaoCategoriaAtributoTalentoForm.getSequencialPreenchimento();
            for (int i = 0; i < strOrdenacao.length; i++)
            {
                CategoriaAtributoTalento objCategoriaAtributoTalento = new CategoriaAtributoTalento();
                objCategoriaAtributoTalento.setIdentificador(Integer.valueOf(strOrdenacao[i]));
                lstOrdenacao.add(objCategoriaAtributoTalento);
            }

            // Ordena as categorias/atributos de talento
            objCategoriaAtributoTalentoFacade.ordenar(lstOrdenacao);

            // Mensagem
            mensagens.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.mensagem.generica", "Ordenao efetuada com sucesso"));
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        // Mensagens
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo categoriaAtributoTalentoPrepararVisualizacao
     */

    public ArrayList categoriaAtributoTalentoPrepararVisualizacao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        session.removeAttribute("strConfirma");

        // List para armazenar resultado da consulta
        List lstCategoriaAtributosTalento = null;
        String strTotalRegistros = "0";

        // Verifica pgina
        int intPagina = DisplaytagUtil.getIntPageValue(request, "dtListagem");
        if (intPagina > 1)
        {
            strTotalRegistros = String.valueOf(session.getAttribute("strTotalRegistros"));
        }

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        try
        {
            // Verifica qual a categoria de talento passada, e obtm objeto para armanenar na sesso
            CategoriaTalento objCategoriaTalento = null;
            if (request.getAttribute("blnEncadeamento") == null && request.getParameter("pagina") == null)
            {
                if (request.getParameter("chave") != null)
                {
                    objCategoriaTalento = objCategoriaAtributoTalentoFacade.obterCategoriaTalentoPelaChave(request.getParameter("chave"));
                    session.setAttribute("objCategoriaTalento", objCategoriaTalento);
                }
                else
                {
                    objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");
                }
            }
            else
            {
                objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");
            }

            int maxRegistros = (DisplaytagUtil.isExporting(request, "dtListagem") ? 0 : 20);

            // Obtm dados
            lstCategoriaAtributosTalento = objCategoriaAtributoTalentoFacade.obterPorCategoriaTalentoPorPagina(objCategoriaTalento, intPagina, maxRegistros);
            if (intPagina == 1)
            {
                strTotalRegistros = String.valueOf(objCategoriaAtributoTalentoFacade.obterTotalRegistrosPorCategoriaTalento(objCategoriaTalento));
                session.setAttribute("strTotalRegistros", strTotalRegistros);
            }
            request.setAttribute("lstCategoriaAtributosTalento", lstCategoriaAtributosTalento);
            request.setAttribute("strTotalRegistros", strTotalRegistros);
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        // Mensagens        
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo detalheCategoriaAtributoTalentoEfetuarInclusao
     */

    public ArrayList detalheCategoriaAtributoTalentoEfetuarInclusao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        // Obtm o form
        DetalheCategoriaAtributoTalentoForm detalheCategoriaAtributoTalentoForm = (DetalheCategoriaAtributoTalentoForm) form;

        // Obtm objeto com a categoria de talento relacionada
        CategoriaTalento objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        // Instacia novo POJO
        CategoriaAtributoTalento objCategoriaAtributoTalento = new CategoriaAtributoTalento();

        try
        {
            // Inclui dados
            objCategoriaAtributoTalento.setCategoriaTalento(objCategoriaTalento);
            if (detalheCategoriaAtributoTalentoForm.getAtributoTalento() != null && !"".equals(detalheCategoriaAtributoTalentoForm.getAtributoTalento()))
            {
                AtributoTalento objAtributoTalento = new AtributoTalento();
                objAtributoTalento.setIdentificador(Integer.valueOf(detalheCategoriaAtributoTalentoForm.getAtributoTalento()));
                objCategoriaAtributoTalento.setAtributoTalento(objAtributoTalento);
            }
            objCategoriaAtributoTalento.setIndicativoObrigatoriedade((detalheCategoriaAtributoTalentoForm.getIndicativoObrigatoriedade() ? "S" : "N"));
            objCategoriaAtributoTalento.setFormacaoDescricao((detalheCategoriaAtributoTalentoForm.getFormacaoDescricao() ? "S" : "N"));
            objCategoriaAtributoTalento.setDicaPreenchimento(detalheCategoriaAtributoTalentoForm.getDicaPreenchimento());
            objCategoriaAtributoTalento.setApelido(detalheCategoriaAtributoTalentoForm.getApelido());
            objCategoriaAtributoTalentoFacade.incluir(objCategoriaAtributoTalento);

            // Mensagem
            mensagens.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.mensagem.generica", ((MessageResources) mapRecursos.get("comum")).getMessage("sigesp.comum.interface.mensagem.inclusao.realizada")));
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }

        // Mensagens        
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo detalheAtributoTalentoOpcaoPrepararAlteracao
     */

    public ArrayList detalheCategoriaAtributoTalentoPrepararAlteracao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        // Obtm o form
        DetalheCategoriaAtributoTalentoForm detalheCategoriaAtributoTalentoForm = (DetalheCategoriaAtributoTalentoForm) form;

        // Obtm a chave
        String strChave;
        if (request.getParameter("chave") != null)
        {
            strChave = request.getParameter("chave");
        }
        else
        {
            strChave = detalheCategoriaAtributoTalentoForm.getIdentificador();
        }

        // Obtm objeto com a categoria de talento relacionada
        CategoriaTalento objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        try
        {
            // Obtm objeto de categoria/atributo de talento
            CategoriaAtributoTalento objCategoriaAtributoTalento = new CategoriaAtributoTalento();
            objCategoriaAtributoTalento = objCategoriaAtributoTalentoFacade.obterPelaChaveComAtributoTalentoECategoriaTalento(strChave);

            // Preenche formulrio
            detalheCategoriaAtributoTalentoForm.setIdentificador(String.valueOf(objCategoriaAtributoTalento.getIdentificador()));
            if (objCategoriaAtributoTalento.getAtributoTalento() != null)
            {
                detalheCategoriaAtributoTalentoForm.setAtributoTalento(String.valueOf(objCategoriaAtributoTalento.getAtributoTalento().getIdentificador()));
            }
            detalheCategoriaAtributoTalentoForm.setIndicativoObrigatoriedade(("S".equals(objCategoriaAtributoTalento.getIndicativoObrigatoriedade()) ? true : false));
            detalheCategoriaAtributoTalentoForm.setFormacaoDescricao(("S".equals(objCategoriaAtributoTalento.getFormacaoDescricao()) ? true : false));
            detalheCategoriaAtributoTalentoForm.setDicaPreenchimento(objCategoriaAtributoTalento.getDicaPreenchimento());
            detalheCategoriaAtributoTalentoForm.setApelido(objCategoriaAtributoTalento.getApelido());

            // Ttulo da tabela de detalhe
            request.setAttribute("strTituloTabelaDetalhe", "Alterao - " + objCategoriaAtributoTalento.getCategoriaTalento().getNome());
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }

        // Marca encadeamento
        request.setAttribute("blnEncadeamento", new Boolean(true));

        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo detalheCategoriaAtributoTalentoPrepararInclusao
     */

    public ArrayList detalheCategoriaAtributoTalentoPrepararInclusao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        // Obtm objeto com o atributo de talento relacionado
        CategoriaTalento objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        try
        {
            // Obtm atributos de talento
            List lstAtributosTalento = objCategoriaAtributoTalentoFacade.obterAtributosTalento();
            request.setAttribute("lstAtributosTalento", lstAtributosTalento);

            // Ttulo da tabela de detalhe
            if (request.getParameter("chave") == null)
            {
                request.setAttribute("strTituloTabelaDetalhe", "Incluso");
            }
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }

        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo exclusaoCategoriaAtributoTalentoPrepararExclusao
     */

    public ArrayList exclusaoCategoriaAtributoTalentoPrepararExclusao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        // Cria bean
        CategoriaAtributoTalento objCategoriaAtributoTalento = null;

        // Cria lista para insero do registro para excluso
        List lstCategoriaAtributosTalento = new ArrayList();

        // Obtm chave para preparao de excluso
        String strChave = request.getParameter("chave");

        try
        {
            // Obtm bean para preparao de excluso
            objCategoriaAtributoTalento = objCategoriaAtributoTalentoFacade.obterPelaChaveComAtributoTalentoECategoriaTalento(strChave);
            lstCategoriaAtributosTalento.add(objCategoriaAtributoTalento);

            // Armazena dados no request
            request.setAttribute("lstCategoriaAtributosTalento", lstCategoriaAtributosTalento);
        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }
        catch (Exception e)
        {
            e.printStackTrace();

        }
        // Mensagens
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

    /**
     * Metodo ordenacaoCategoriaAtributoTalentoPrepararVisualizacao
     */

    public ArrayList ordenacaoCategoriaAtributoTalentoPrepararVisualizacao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Obtm sesso
        HttpSession session = request.getSession();

        // Obtm objeto com a categoria de talento relacionada
        CategoriaTalento objCategoriaTalento = (CategoriaTalento) session.getAttribute("objCategoriaTalento");

        // Instancia Facade
        CategoriaAtributoTalentoFacade objCategoriaAtributoTalentoFacade = new CategoriaAtributoTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS);

        try
        {
            // Obtm lista para ordenao
            List lstCategoriaAtributosTalento = objCategoriaAtributoTalentoFacade.obterTodosPorCategoriaTalento(objCategoriaTalento);

            // Armazena dados no request
            request.setAttribute("lstCategoriaAtributosTalento", lstCategoriaAtributosTalento);

            // Ttulo da tabela de detalhe
            request.setAttribute("strTituloTabelaDetalhe", "Ordenao de categoria/atributos de talento");

        }
        catch (CDException cde)
        {
            if (log.isErrorEnabled())
            {
                log.error(cde.obterExcecoes());
            }

            erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", cde.obterMensagem()));
        }

        // Mensagens
        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);
    }

}
