package br.gov.camara.visao.bancotalentosapoio.sequencia;

import java.util.ArrayList;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import br.gov.camara.biblioteca.util.ConstantesSingleton;
import br.gov.camara.exception.CDException;
import br.gov.camara.negocio.bancotalentos.facade.ConsultaTalentoFacade;
import br.gov.camara.negocio.bancotalentos.util.ConfiguracaoDaIndexacaoTextual;
import br.gov.camara.negocio.bancotalentos.util.ConstantesBancoTalentos;
import br.gov.camara.negocio.bancotalentos.util.DadosIndexacaoManual;
import br.gov.camara.seguranca.SegurancaWeb;
import br.gov.camara.servlet.timer.ProgramadorTarefas;
import br.gov.camara.visao.bancotalentosapoio.util.TarefaReindexacaoManual;
import sigesp.comum.util.struts.SigespSequencia;
import sigesp.comum.util.struts.actions.ActionMessagesUtil;

/**
 * Sequencia GerenciamentoLuceneSequencia
 */

public final class GerenciamentoLuceneSequencia extends SigespSequencia
{
    // Inicializa o log

    private static Log log = LogFactory.getLog(GerenciamentoLuceneSequencia.class);

    /**
     * Metodo construtor
     *
     * @param mapping Mapeamento executado
     * @param form Formulário associado (quando houver)
     * @param request Request
     * @param response Response
     * @param erros Colecao de erros que já ocorreram
     * @param mensagens Colecao de mensagens a serem exibidas
     * @param GerenciamentoLuceneAction Classe Action associada
     */

    public GerenciamentoLuceneSequencia(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response, ActionMessages erros,
            ActionMessages mensagens, Action action, Map mapRecursos)
    {
        this.mapping = mapping;
        this.form = form;
        this.request = request;
        this.response = response;
        this.errosRequest = erros;
        this.action = action;
        this.mensagensRequest = mensagens;
        this.arlMensagens = new ArrayList();
        this.mapRecursos = mapRecursos;

        this.erros = new ActionMessages();
        this.mensagens = new ActionMessages();
    }

    // Metodos chamados

    /**
     * Metodo gerenciamentoLuceneEfetuarReindexacao
     */

    public ArrayList gerenciamentoLuceneEfetuarReindexacao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Recupera sessao
        HttpSession session = request.getSession();

        // Efetuar validacoes / preparacoes necessarias

        // Exemplo para adicionar um erro:
        // erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", "Mensagem de erro a ser exibida"));

        if (erros.isEmpty())
        {
            // Agendar
            if (!ProgramadorTarefas.getInstance().estaAgendada(TarefaReindexacaoManual.class.getName()))
            {
                TarefaReindexacaoManual tarefaReindexacaoManual = new TarefaReindexacaoManual(SegurancaWeb.obterSegurancaWeb(request.getSession()).obterUsuarioAutenticado().obterLogin(), (String) ConstantesSingleton.getInstance().getObjeto("idMaquina"), true);
                ProgramadorTarefas.getInstance().agendar(tarefaReindexacaoManual);
            }

            // Exemplo de envio de uma mensagem (sucesso) para o usuario
            mensagens.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.mensagem.generica", "Reindexao manual agendada. Verifique a data de concluso para fazer a pesquisa textual."));
        }

        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);

    }

    /**
     * Metodo gerenciamentoLucenePrepararVisualizacao
     */

    public ArrayList gerenciamentoLucenePrepararVisualizacao()
    {
        if (log.isDebugEnabled())
        {
            log.debug("Entrada no metodo");
        }

        // Recupera sessao
        HttpSession session = request.getSession();

        try
        {
            DadosIndexacaoManual dadosInicioIndexacaoManual = ConfiguracaoDaIndexacaoTextual.getInstance().lerDadosIndexacaoManual();
            request.setAttribute("dadosInicioIndexacaoManual", dadosInicioIndexacaoManual);

            String dataUltimaIndexacaoManual = ConfiguracaoDaIndexacaoTextual.getInstance().getDataUltimaIndexacaoManual();
            request.setAttribute("dataUltimaIndexacaoManual", dataUltimaIndexacaoManual);

            if (session.getAttribute("strTotalPessoasComTalentos") == null)
            {
                session.setAttribute("strTotalPessoasComTalentos", String.valueOf((new ConsultaTalentoFacade(ConstantesBancoTalentos.CONEXAO_TALENTOS)).obterTotalPessoasComTalentos()));
            }
        }
        catch (CDException e)
        {
            log.error(e);
            this.erros.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("sigesp.comum.erro.generico", e.getMensagem()));
        }

        arlMensagens.add(ActionMessagesUtil.INDEX_MENSAGENS, mensagens);
        arlMensagens.add(ActionMessagesUtil.INDEX_ERROS, erros);

        return (arlMensagens);

    }

}
