/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.visao.bancotalentosgestao.util;

import javax.servlet.http.HttpSession;

import br.gov.camara.negocio.exception.NegocioException;
import br.gov.camara.seguranca.SegurancaWeb;
import br.gov.camara.seguranca.UsuarioAutenticado;

/**
 * Mtodos Utilitrios de permisso para executar operaes no Sistema de Gesto de Talentos
 *
 * @author $author$
 * @version $Revision$
 */
public class TalentosGestaoPermissao
{
    public static final String INDICATIVO_MODULO_APOIO = "indicativoModuloApoio";

    public static void verificarUsuarioLogadoEhPessoaTalento(Integer identificadorPessoa, HttpSession sessao) throws NegocioException
    {
        // Verifica se a avaliao informada  vlida
        if (identificadorPessoa == null)
        {
            throw new NegocioException("O identificador da pesssoa informado  invlido");
        }

        SegurancaWeb objSegurancaWeb = SegurancaWeb.obterSegurancaWeb(sessao);

        if (objSegurancaWeb == null)
        {
            // No deveria ocorrer, pois o ActionPlugin deveria pegar antes e redirecionar para a tela de logon,
            // mas em todos os casos...
            throw new NegocioException("O registro de sua autenticao no foi encontrado. Faa um novo login.");
        }

        UsuarioAutenticado usuarioAutenticado = objSegurancaWeb.obterUsuarioAutenticado();
        if (usuarioAutenticado == null)
        {
            // No deveria ocorrer, pois o ActionPlugin deveria pegar antes e redirecionar para a tela de logon,
            // mas em todos os casos...
            throw new NegocioException("O registro de sua autenticao no foi encontrado. Faa um novo login.");
        }

        if (usuarioAutenticado.obterIdentificador().intValue() != identificadorPessoa.intValue())
        {
            throw new NegocioException("Voc no est autorizado a realizar esta operao");
        }
    }

    public static boolean verificarOrigemModuloApoio(HttpSession session) throws NegocioException
    {
        // Acesso NO est sendo feito pelo mdulo APOIO ???
        boolean blnRetorno = ("true".equals(session.getAttribute(INDICATIVO_MODULO_APOIO)));

        return blnRetorno;
    }
}
