/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

/*
 * Created on 21/11/2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sigesp.comum.util.hibernate;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Container para as conexes Hibernate lidas e seus dados
 * 
 */
public class ColecaoDadosConexao
{
    private List colecaoDadosConexao = null;

    /**
     * Inicializa o array dos dados das conexes
     *
     */
    public ColecaoDadosConexao()
    {
        colecaoDadosConexao = new ArrayList();
    }

    /**
     * Adiciona uma conexo com seus dados no array
     * @param dadosConexao Item (DadosConexao) a ser adicionado
     */
    public void add(DadosConexao dadosConexao)
    {
        colecaoDadosConexao.add(dadosConexao);
    }

    /**
     * Retorna a conexo informada (pelo nome) e seus dados   
     * @param nomeConexao Nome da conexo a ser retornada
     * @return Retorna a conexo especificada ou null se ela no foi encontrada
     */
    public DadosConexao obterDadosConexao(String nomeConexao)
    {
        DadosConexao dadosConexao = null;

        for (int i = 0; i < colecaoDadosConexao.size(); i++)
        {
            DadosConexao dadosConexaoTemp = (DadosConexao) colecaoDadosConexao.get(i);
            List nomesConexao = dadosConexaoTemp.getNomesConexao();
            for (int j = 0; j < nomesConexao.size(); j++)
            {
                if (nomeConexao.equals((String) nomesConexao.get(j)))
                {
                    dadosConexao = dadosConexaoTemp;
                    i = colecaoDadosConexao.size();
                    j = nomesConexao.size();
                }
            }
        }
        return dadosConexao;
    }

    /**
     * Obtm o Iterator da coleo de conexes 
     * @return Iterator da coleo de conexes
     */
    public Iterator obterIterator()
    {
        return colecaoDadosConexao.iterator();
    }

    /**
     * Verifica se a conexo especificada existe ou no na coleo
     * @param nomeConexao Nome da conexo procurada
     * @return True se a conexo foi encontrada, caso contrrio false
     */
    public boolean existeConexao(String nomeConexao)
    {
        if (obterDadosConexao(nomeConexao) == null)
        {
            return false;
        }
        else return true;
    }

    /**
     * Verifica se a conexo especificada existe ou no na coleo
     * @param nomeConexao Nome da conexo procurada
     * @return True se a conexo foi encontrada, caso contrrio false
     */
    public DadosConexao obterConexaoPeloIndice(int indice)
    {
        return (DadosConexao) colecaoDadosConexao.get(indice);
    }

    /**
     * Retorna a quantidade de itens na coleo
     * @return Tamanho da coleo
     */
    public int obterTamanho()
    {
        return colecaoDadosConexao.size();
    }
}