/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package sigesp.comum.util.tag;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.TagSupport;

import sigesp.comum.util.bean.Bean;
import sigesp.comum.util.exception.FabricaBeansException;

/**
 * Classe Tag Handler para colunas da grade
 */
public class ColunaGradeTag extends TagSupport
{
    private static final long serialVersionUID = -369505952967330090L;
    private String strLargura = "";
    private String strTitulo = "";
    private String strPropriedade = "";
    private String strAlinhamento = "";
    private String strValor = "";
    private String strParametroID = "";
    private String strParametroNome = "";
    private String strHref = "";

    /**
     * Obtm largura
     *
     * @return Contedo de largura
     */
    public String getLargura()
    {
        return strLargura;
    }

    /**
     * Atribui largura
     *
     * @param strLargura Contedo de largura
     */
    public void setLargura(String strLargura)
    {
        this.strLargura = strLargura;
    }

    /**
     * Obtm ttulo
     *
     * @return Contedo do ttulo
     */
    public String getTitulo()
    {
        return strTitulo;
    }

    /**
     * Atribui ttulo
     *
     * @param strTitulo Contedo do ttulo
     */
    public void setTitulo(String strTitulo)
    {
        this.strTitulo = strTitulo;
    }

    /**
     * Obtm propriedade
     *
     * @return Contedo de proprieadade
     */
    public String getPropriedade()
    {
        return strPropriedade;
    }

    /**
     * Atribui propriedade
     *
     * @param strPropriedade Contedo de propriedade
     */
    public void setPropriedade(String strPropriedade)
    {
        this.strPropriedade = strPropriedade;
    }

    /**
     * Obtm valor
     *
     * @return Contedo de valor
     */
    public String getValor()
    {
        return strValor;
    }

    /**
     * Atribui valor
     *
     * @param strValor Contedo de valor
     */
    public void setValor(String strValor)
    {
        this.strValor = strValor;
    }

    /**
     * Obtm identificador do parmetro
     *
     * @return Contedo do identificador do parmetro
     */
    public String getParametroID()
    {
        return strParametroID;
    }

    /**
     * Atribui identificador do parmetro
     *
     * @param strParametroID Contedo do identificador do parmetro
     */
    public void setParametroID(String strParametroID)
    {
        this.strParametroID = strParametroID;
    }

    /**
     * Obtm nome do parmetro
     *
     * @return Contedo do nome do parmetro
     */
    public String getParametroNome()
    {
        return strParametroNome;
    }

    /**
     * Atribui nome do parmetro
     *
     * @param strParametroNome Contedo do nome do parmetro
     */
    public void setParametroNome(String strParametroNome)
    {
        this.strParametroNome = strParametroNome;
    }

    /**
     * Obtm href
     *
     * @return Contedo do href
     */
    public String getHref()
    {
        return strHref;
    }

    /**
     * Atribui href
     *
     * @param strHref Contedo do href
     */
    public void setHref(String strHref)
    {
        this.strHref = strHref;
    }

    /**
     * Inicializao da tag
     *
     * @return Ao da tag
     *
     * @throws JspTagException se ocorrer algum erro relacionado a tag
     */
    public int doStartTag() throws JspTagException
    {
        GradeTag parent = (GradeTag) findAncestorWithClass(this, GradeTag.class);
        if (parent == null)
        {
            throw new JspTagException("Coluna sem grade");
        }

        // Declaraes
        List lstTabela = null;
        HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
        HttpSession session = request.getSession();

        // Verifica pageContext
        if (pageContext.getAttribute(parent.getLista()) != null)
        {
            lstTabela = (List) pageContext.getAttribute(parent.getLista());
        }

        // Verifica session
        if (session.getAttribute(parent.getLista()) != null)
        {
            lstTabela = (List) session.getAttribute(parent.getLista());
        }

        // Verifica request
        if (request.getAttribute(parent.getLista()) != null)
        {
            lstTabela = (List) request.getAttribute(parent.getLista());
        }

        Iterator itrTabela = lstTabela.iterator();

        // Obtm configurao de ttulos
        List arlTitulo = parent.getTitulo();

        // Obtm configurao de larguras
        List arlLargura = parent.getLarguraColuna();

        // Obtm configurao de colunas
        List arlConteudo = parent.getConteudo();

        // Cria configurao de linhas            
        List arlColuna = new ArrayList();

        // Adiciona ttulo
        arlTitulo.add(strTitulo);

        // Adiciona ttulo
        arlLargura.add(strLargura);

        // Itera beans e adiciona ao contedo
        while (itrTabela.hasNext())
        {
            try
            {
                if (!"".equals(strPropriedade))
                {
                    Bean beaTabela = new Bean(itrTabela.next());
                    arlColuna.add(beaTabela.obterPropriedade(strPropriedade));
                }
                else
                {
                    Bean beaTabela = new Bean(itrTabela.next());
                    arlColuna.add("<a href=\""
                            + strHref
                            + "?"
                            + strParametroID
                            + "="
                            + beaTabela.obterPropriedade(strParametroNome)
                            + "\">"
                            + strValor
                            + "</a>");
                }
            }
            catch (FabricaBeansException fbe)
            {}
        }

        // Armazena coluna
        arlConteudo.add(arlColuna);

        // Retorno
        return (SKIP_BODY);
    }
}
