/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package sigesp.comum.util.tag;

import java.io.IOException;

import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.displaytag.decorator.ColumnDecorator;

/**
 * Classe Tag Handler de coluna
 */
public class ColunaTag extends BodyTagSupport
{
    /**
	 * 
	 */
	private static final long serialVersionUID = -1297013374236698650L;

	private String strSpan = "";

    private String strLargura = "";

    private String strDecorator = "";

    /**
     * Obtm configurao de span
     *
     * @return Contedo de span
     */
    public String getSpan()
    {
        return strSpan;
    }

    /**
     * Atribui configurao de span
     *
     * @param strSpan Contedo de span
     */
    public void setSpan(String strSpan)
    {
        this.strSpan = strSpan;
    }

    /**
     * Obtm largura
     *
     * @return Contedo de largura
     */
    public String getLargura()
    {
        return strLargura;
    }

    /**
     * Atribui largura
     *
     * @param strBorda Contedo de largura
     */
    public void setLargura(String strLargura)
    {
        this.strLargura = strLargura;
    }

    /**
     * Obtm decorator
     *
     * @return String decorator formatado
     */
    public String getDecorator()
    {
        return strDecorator;
    }

    /**
     * Atribui decorator
     *
     * @param strDecorator
     */
    public void setDecorator(String strDecorator)
    {
        this.strDecorator = strDecorator;
    }

    /**
     * Inicializao da tag
     *
     * @return Ao da tag
     *
     * @throws JspTagException se ocorrer algum erro relacionado a tag
     */
    public int doStartTag() throws JspTagException
    {
        TabelaTag parent = (TabelaTag) findAncestorWithClass(this, TabelaTag.class);
        if (parent == null)
        {
            throw new JspTagException("Coluna sem tabela");
        }

        return (EVAL_BODY_BUFFERED);
    }

    /**
     * Finalizao da tag
     *
     * @return Ao da tag
     */
    public int doAfterBody()
    {
        try
        {
            String Texto = "";
            BodyContent body = getBodyContent();
            JspWriter out = body.getEnclosingWriter();
            Texto = "<td class=\"tableCell\""
                    + ("".equals(strSpan) ? "" : (" colspan=\"" + strSpan + "\""))
                    + ("".equals(strLargura) ? "" : " width=\"" + strLargura + "\"")
                    + ">";
            if ((strDecorator != null) && (!strDecorator.equals("")))
            {
                ColumnDecorator objCol = null;
                objCol = loadColumnDecorator(strDecorator);
                Texto += objCol.decorate(body.getString());
            }
            else
            {
                Texto += body.getString();
            }
            Texto += "</td>";

            out.print(Texto);
        }
        catch (IOException ioe)
        {}
        catch (Exception e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return (SKIP_BODY);
    }

    /**
     * Se for definido uma classe decorator, ser feita uma instncia da mesma e retornada.
     * 
     * @param columnDecoratorName String nome da classe do Decorator
     * 
     * @return instncia de ColumnDecorator
     * 
     */
    private ColumnDecorator loadColumnDecorator(String columnDecoratorName)
    {
        if (columnDecoratorName == null || columnDecoratorName.length() == 0)
        {
            return null;
        }
        try
        {
            Class decoratorClass = Class.forName(columnDecoratorName);
            return (ColumnDecorator) decoratorClass.newInstance();
        }

        catch (ClassNotFoundException e)
        {}
        catch (InstantiationException e)
        {}
        catch (IllegalAccessException e)
        {}
        catch (ClassCastException e)
        {}
        return null;

    }

}
