/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package sigesp.comum.util.tag;

import java.io.IOException;

import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * Classe Tag Hanlder de linha
 */
public class LinhaTag extends TagSupport
{
    private static final long serialVersionUID = 6941630687356544339L;
    private String strCabecalho = "nao";
    private String strSpan = "";
    private String strLargura = "";

    /**
     * Obtm configurao de cabealho
     *
     * @return Contedo de cabealho
     */
    public String getCabecalho()
    {
        return strCabecalho;
    }

    /**
     * Atribui configurao de cabealho
     *
     * @param strCabecalho Contedo de cabealho
     */
    public void setCabecalho(String strCabecalho)
    {
        this.strCabecalho = strCabecalho;
    }

    /**
     * Obtm configurao de span
     *
     * @return Contedo de span
     */
    public String getSpan()
    {
        return strSpan;
    }

    /**
     * Atribui configurao de span
     *
     * @param strSpan Contedo de span
     */
    public void setSpan(String strSpan)
    {
        this.strSpan = strSpan;
    }

    /**
     * Obtm largura
     *
     * @return Contedo de largura
     */
    public String getLargura()
    {
        return strLargura;
    }

    /**
     * Atribui largura
     *
     * @param strBorda Contedo de largura
     */
    public void setLargura(String strLargura)
    {
        this.strLargura = strLargura;
    }

    /**
     * Inicializao da tag
     *
     * @return Ao da tag
     *
     * @throws JspTagException se ocorrer algum erro relacionado a tag
     */
    public int doStartTag() throws JspTagException
    {
        TabelaTag parent = (TabelaTag) findAncestorWithClass(this, TabelaTag.class);
        if (parent == null)
        {
            throw new JspTagException("Linha fora de tabela");
        }

        try
        {
            JspWriter out = pageContext.getOut();

            // Verifica se  cabealho

            if ("sim".equals(strCabecalho))
            {
                out.print("<tr class=\"tableRowHeader\" " + ("".equals(strLargura) ? "" : " width=\"" + strLargura + "\""));
            }
            else
            {
                if ("impar".equals(parent.getLinha()))
                {
                    out.print("<tr class=\"tableRowOdd\" " + ("".equals(strLargura) ? "" : " width=\"" + strLargura + "\""));
                    parent.setLinha("par");
                }
                else
                {
                    out.print("<tr class=\"tableRowEven\" " + ("".equals(strLargura) ? "" : " width=\"" + strLargura + "\""));
                    parent.setLinha("impar");
                }
            }

            // Verifica se h span
            if ("".equals(strSpan))
            {
                out.print(" rowspan=\"" + strSpan + "\"");
            }

            // Adiciona fechamento da tag
            out.print(">");
        }
        catch (IOException ioe)
        {}

        return (EVAL_BODY_INCLUDE);
    }

    /**
     * Finalizao da tag
     *
     * @return Ao da tag
     */
    public int doEndTag()
    {
        try
        {
            JspWriter out = pageContext.getOut();

            out.print("</tr>");
        }
        catch (IOException ioe)
        {}

        return (EVAL_PAGE);
    }
}
