/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package sigesp.comum.util.tag;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * Classe Tag Handler para tabela
 */
public class NivelTag extends TagSupport
{
    private static final long serialVersionUID = -4424187600477248538L;
    private String strLista = "";
    private String strLink = "";
    private String strParametro = "";

    /**
     * Obtm configurao de lista
     *
     * @return Contedo de lista
     */
    public String getLista()
    {
        return strLista;
    }

    /**
     * Atribui configurao de lista
     *
     * @param strLinha Contedo de lista
     */
    public void setLista(String strLista)
    {
        this.strLista = strLista;
    }

    /**
     * Obtm configurao de link
     *
     * @return Contedo de link
     */
    public String getLink()
    {
        return strLink;
    }

    /**
     * Atribui configurao de link
     *
     * @param strLink Contedo de link
     */
    public void setLink(String strLink)
    {
        this.strLink = strLink;
    }

    /**
     * Obtm configurao de parmetro
     *
     * @return Contedo de parmetro
     */
    public String getParametro()
    {
        return strLink;
    }

    /**
     * Atribui configurao de parmetro
     *
     * @param strParametro Contedo de parmetro
     */
    public void setParametro(String strParametro)
    {
        this.strParametro = strParametro;
    }

    /**
     * Finalizao da tag
     *
     * @return Ao da tag
     */
    public int doEndTag()
    {
        JspWriter out = pageContext.getOut();

        // Verifica qual contexto est a lista

        try
        {
            List lstLista = null;
            if (pageContext.getRequest().getAttribute(strLista) != null)
            {
                lstLista = (List) pageContext.getRequest().getAttribute(strLista);
            }
            if (pageContext.getSession().getAttribute(strLista) != null)
            {
                lstLista = (List) pageContext.getSession().getAttribute(strLista);
            }
            if (pageContext.getAttribute(strLista) != null)
            {
                lstLista = (List) pageContext.getAttribute(strLista);
            }

            // Itera lista

            Iterator itrLista = lstLista.iterator();
            String strSaida = "";
            while (itrLista.hasNext())
            {
                String strItem = (String) itrLista.next();
                String[] strItemTokens = strItem.split(";");
                strSaida += "<a href=\""
                    + strLink
                    + "?"
                    + strParametro
                    + "="
                    + strItemTokens[0]
                    + "\" title=\""
                    + strItemTokens[2]
                    + "\">"
                    + strItemTokens[0]
                    + "</a>"
                    + "\n";
                if (itrLista.hasNext())
                {
                    strSaida += " > ";
                }
            }
            out.println(strSaida);
        }
        catch (IOException ioe)
        {

        }
        return (EVAL_PAGE);
    }
}
