/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package sigesp.comum.util.tag;

import java.util.Iterator;
import java.util.List;

import javax.servlet.jsp.tagext.TagSupport;

import sigesp.comum.util.bean.Bean;
import sigesp.comum.util.exception.FabricaBeansException;

/**
 * Classe Tag Handler para tabela
 */
public class ParametroTag extends TagSupport
{
    private static final long serialVersionUID = 1256661486017070976L;

    /** Nome da lista onde est(o) o(s) bean(s) */
    private String strLista = "";

    /** Nome da propriedade do bean a ser recuperada */
    private String strPropriedade = "";

    /** Nome do atributo que ser colocado no contexto */
    private String strAtributo = "";

    /** Escopo de onde ser obtido o valor */
    private String strContexto = "";

    /** Nome do parmetro a ser recuperado */
    private String strParametro = "";

    /**
     * Obtm configurao de lista
     *
     * @return Contedo de lista
     */
    public String getLista()
    {
        return strLista;
    }

    /**
     * Atribui configurao de lista
     *
     * @param strLinha Contedo de lista
     */
    public void setLista(String strLista)
    {
        this.strLista = strLista;
    }

    /**
     * Obtm configurao de propriedade
     *
     * @return Contedo de propriedade
     */
    public String getPropriedade()
    {
        return strPropriedade;
    }

    /**
     * Atribui configurao de propriedade
     *
     * @param strLinha Contedo de propriedade
     */
    public void setPropriedade(String strPropriedade)
    {
        this.strPropriedade = strPropriedade;
    }

    /**
     * Obtm configurao de atributo
     *
     * @return Contedo de atributo
     */
    public String getAtributo()
    {
        return strAtributo;
    }

    /**
     * Atribui configurao de atributo
     *
     * @param strBorda Contedo de atributo
     */
    public void setAtributo(String strAtributo)
    {
        this.strAtributo = strAtributo;
    }

    /**
     * Obtm contexto
     *
     * @return Contedo de contexto
     */
    public String getContexto()
    {
        return strContexto;
    }

    /**
     * Atribui contexto
     *
     * @param strBorda Contedo de contexto
     */
    public void setContexto(String strContexto)
    {
        this.strContexto = strContexto;
    }

    /**
     * Finalizao da tag
     *
     * @return Ao da tag
     */
    public int doEndTag()
    {
        try
        {
            String strResultado = "";

            if (strParametro != null && !"".equals(strParametro))
            {
                // Verifica qual em contexto est o parmetro

                String strString = null;
                if ("request".equalsIgnoreCase(strContexto) && pageContext.getRequest().getParameter(strParametro) != null)
                {
                    strString = (String) pageContext.getRequest().getParameter(strParametro);
                }
                else if ("session".equalsIgnoreCase(strContexto) && pageContext.getSession().getAttribute(strParametro) != null)
                {
                    strString = (String) pageContext.getSession().getAttribute(strParametro);
                }
                else if (pageContext.getAttribute(strParametro) != null)
                {
                    strString = (String) pageContext.getAttribute(strParametro);
                }

                strResultado += strString;
            }
            else
            {
                // Verifica qual contexto est a lista

                List lstLista = null;
                if ("request".equalsIgnoreCase(strContexto) && pageContext.getRequest().getAttribute(strLista) != null)
                {
                    lstLista = (List) pageContext.getRequest().getAttribute(strLista);
                }
                else if ("session".equalsIgnoreCase(strContexto) && pageContext.getSession().getAttribute(strLista) != null)
                {
                    lstLista = (List) pageContext.getSession().getAttribute(strLista);
                }
                else if (pageContext.getAttribute(strLista) != null)
                {
                    lstLista = (List) pageContext.getAttribute(strLista);
                }

                // Itera lista

                Iterator itrLista = lstLista.iterator();

                while (itrLista.hasNext())
                {
                    Bean beaLista = new Bean(itrLista.next());
                    strResultado += beaLista.obterPropriedade(strPropriedade) + (itrLista.hasNext() ? ";" : "");
                }

            }

            // Armazena no contexto desejado

            if ("request".equals(strContexto))
            {
                pageContext.getRequest().setAttribute(strAtributo, strResultado);
            }
            if ("session".equals(strContexto))
            {
                pageContext.getSession().setAttribute(strAtributo, strResultado);
            }
            if ("pageContext".equals(strContexto))
            {
                pageContext.setAttribute(strAtributo, strResultado);
            }
        }
        catch (FabricaBeansException fbe)
        {}

        return (EVAL_PAGE);
    }

    /**
     * @return Returns the strParametro.
     */
    public String getParametro()
    {
        return this.strParametro;
    }

    /**
     * @param strParametro The strParametro to set.
     */
    public void setParametro(String strParametro)
    {
        this.strParametro = strParametro;
    }
}
