/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package sigesp.comum.util.tag;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * Classe Tag Handler para tabela
 */
public class TabelaTag extends TagSupport
{
    private static final long serialVersionUID = 4288318563127126013L;
    private String strLinha = "impar";
    private String strBorda = "0";
    private String strLargura = "";

    /**
     * Obtm configurao de linha
     *
     * @return Contedo de linha
     */
    public String getLinha()
    {
        return strLinha;
    }

    /**
     * Atribui configurao de linha
     *
     * @param strLinha Contedo de linha
     */
    public void setLinha(String strLinha)
    {
        this.strLinha = strLinha;
    }

    /**
     * Obtm configurao de borda
     *
     * @return Contedo de borda
     */
    public String getBorda()
    {
        return strBorda;
    }

    /**
     * Atribui configurao de borda
     *
     * @param strBorda Contedo de borda
     */
    public void setBorda(String strBorda)
    {
        this.strBorda = strBorda;
    }

    /**
     * Obtm largura
     *
     * @return Contedo de largura
     */
    public String getLargura()
    {
        return strLargura;
    }

    /**
     * Atribui largura
     *
     * @param strBorda Contedo de largura
     */
    public void setLargura(String strLargura)
    {
        this.strLargura = strLargura;
    }

    /**
     * Inicializao da tag
     *
     * @return Ao da tag
     */
    public int doStartTag()
    {
        try
        {
            JspWriter out = pageContext.getOut();
            out.print(
                "<table class=\"table\" cellspacing=\"0\" cellpadding=\"4\" bordercolor=\"#FFFFFF\" "
                    + "bordercolorlight=\"#8D8D8D\" border=\" "
                    + strBorda
                    + "\" "
                    + ("".equals(strLargura) ? "" : " width=\"" + strLargura + "\"")
                    + ">");
        }
        catch (IOException ioe)
        {
        }

        return (EVAL_BODY_INCLUDE);
    }

    /**
     * Finalizao da tag
     *
     * @return Ao da tag
     */
    public int doEndTag()
    {
        try
        {
            JspWriter out = pageContext.getOut();
            out.print("</table>");
        }
        catch (IOException ioe)
        {
        }

        return (EVAL_PAGE);
    }
}
