
CREATE TABLE ATRIBUTOTALENTO (
       IDEATRIBUTO          NUMBER(10) NOT NULL,
       IDEATRIBUTOPAI       NUMBER(10) NULL,
       NOMATRIBUTO          VARCHAR2(255 BYTE) NOT NULL,
       IDETIPOHTML          NUMBER(10) NOT NULL,
       DESMASCARA           VARCHAR2(255 BYTE) NULL,
       IDETABELAAPOIOMM     NUMBER(10) NULL,
       INDPESQUISA          CHAR(1 BYTE) DEFAULT 'N' NOT NULL,
       DESPESQUISA          VARCHAR2(255 BYTE) NULL,
       INDTIPODADO          CHAR(1 BYTE) NULL
                                   CHECK (indTipoDado IN ('T', 'N', 'D'))
);

CREATE UNIQUE INDEX UKATRIBUTOTALENTO_IDEAPOMM ON ATRIBUTOTALENTO
(
       IDETABELAAPOIOMM               ASC
);

CREATE UNIQUE INDEX UKATRIBUTOTALENTO_NOMATRIBUTO ON ATRIBUTOTALENTO
(
       NOMATRIBUTO                    ASC
);

CREATE INDEX IXATRIBUTOTALENTO_IDETIPOHTML ON ATRIBUTOTALENTO
(
       IDETIPOHTML                    ASC
);

CREATE INDEX IXATRIBTALENTO_IDEATRIBPAI ON ATRIBUTOTALENTO
(
       IDEATRIBUTOPAI                 ASC
);


ALTER TABLE ATRIBUTOTALENTO
       ADD  ( PRIMARY KEY (IDEATRIBUTO) ) ;


CREATE TABLE ATRIBUTOTALENTOOPCAO (
       IDEATRIBUTOOPCAO     NUMBER(10) NOT NULL,
       IDEATRIBUTO          NUMBER(10) NOT NULL,
       IDEATRIBUTOOPCAOPAI  NUMBER(10) NULL,
       DESATRIBUTOOPCAO     VARCHAR2(255 BYTE) NOT NULL,
       IDETABELAAPOIOORIGEM NUMBER(10) NULL
);

CREATE INDEX IXATRIBTALENTOOPCAO_IDEATRIB ON ATRIBUTOTALENTOOPCAO
(
       IDEATRIBUTO                    ASC
);

CREATE INDEX IXATRIBTALOPCAO_IDEATRIBOPPAI ON ATRIBUTOTALENTOOPCAO
(
       IDEATRIBUTOOPCAOPAI            ASC
);


ALTER TABLE ATRIBUTOTALENTOOPCAO
       ADD  ( PRIMARY KEY (IDEATRIBUTOOPCAO) ) ;


CREATE TABLE ATRIBUTOTALENTOVALORADO (
       IDEATRIBUTOVALORADO  NUMBER(10) NOT NULL,
       IDETALENTO           NUMBER(10) NOT NULL,
       IDECATEGORIAATRIBUTO NUMBER(10) NOT NULL,
       DESVALORACAO         VARCHAR2(3000 BYTE) NULL,
       IDEATRIBUTOOPCAO     NUMBER(10) NULL
);

CREATE INDEX IXATRIBTALVALORADO_IDETAL ON ATRIBUTOTALENTOVALORADO
(
       IDETALENTO                     ASC
);

CREATE INDEX IXATRIBTALVALORADO_IDECATATRIB ON ATRIBUTOTALENTOVALORADO
(
       IDECATEGORIAATRIBUTO           ASC
);


ALTER TABLE ATRIBUTOTALENTOVALORADO
       ADD  ( PRIMARY KEY (IDEATRIBUTOVALORADO) ) ;


CREATE TABLE CATEGORIAATRIBUTOTALENTO (
       IDECATEGORIAATRIBUTO NUMBER(10) NOT NULL,
       SEQPREENCHIMENTO     NUMBER(2) NOT NULL,
       IDECATEGORIA         NUMBER(10) NOT NULL,
       IDEATRIBUTO          NUMBER(10) NOT NULL,
       INDOBRIGATORIEDADE   CHAR(1 BYTE) NOT NULL,
       INDFORMACAODESCRICAO CHAR(1 BYTE) NOT NULL
                                   CHECK (indFormacaoDescricao in ('S', 'N')),
       NOMAPELIDO           VARCHAR2(255 BYTE) NULL,
       DESDICAPREENCHIMENTO VARCHAR2(255 BYTE) NULL
);

CREATE INDEX IXCATATRIBTAL_IDEATRIBUTO ON CATEGORIAATRIBUTOTALENTO
(
       IDEATRIBUTO                    ASC
);

CREATE INDEX IXCATATRIBTAL_IDECATEGORIA ON CATEGORIAATRIBUTOTALENTO
(
       IDECATEGORIA                   ASC
);


ALTER TABLE CATEGORIAATRIBUTOTALENTO
       ADD  ( PRIMARY KEY (IDECATEGORIAATRIBUTO) ) ;


CREATE TABLE CATEGORIATALENTO (
       IDECATEGORIA         NUMBER(10) NOT NULL,
       NOMCATEGORIA         VARCHAR2(255 BYTE) NOT NULL,
       DESCATEGORIA         VARCHAR2(2000 BYTE) NULL,
       DESDICAPREENCHIMENTO VARCHAR2(255 BYTE) NULL,
       INDUNICIDADE         CHAR(1 BYTE) DEFAULT 'N' NOT NULL
                                   CHECK (indUnicidade in ('S', 'N')),
       SEQORDENACAO         NUMBER(5) NOT NULL
);


ALTER TABLE CATEGORIATALENTO
       ADD  ( PRIMARY KEY (IDECATEGORIA) ) ;


CREATE TABLE FILTROCONSULTA (
       IDEFILTROCONSULTA    NUMBER(10) NOT NULL,
       IDETIPOFILTROCONSULTA NUMBER(10) NULL,
       NOMFILTROCONSULTA    VARCHAR2(255) NULL
);

CREATE INDEX XIF1FILTROCONSULTA ON FILTROCONSULTA
(
       IDETIPOFILTROCONSULTA          ASC
);


ALTER TABLE FILTROCONSULTA
       ADD  ( PRIMARY KEY (IDEFILTROCONSULTA) ) ;


CREATE TABLE FILTROCONSULTAGRUPO (
       IDEFILTROCONSULTA    NUMBER(10) NOT NULL,
       CODGRUPO             NUMBER(10) NOT NULL
);

CREATE INDEX XIF1FILTROCONSULTAGRUPO ON FILTROCONSULTAGRUPO
(
       IDEFILTROCONSULTA              ASC
);

CREATE INDEX XIF2FILTROCONSULTAGRUPO ON FILTROCONSULTAGRUPO
(
       CODGRUPO                       ASC
);


ALTER TABLE FILTROCONSULTAGRUPO
       ADD  ( PRIMARY KEY (IDEFILTROCONSULTA, CODGRUPO) ) ;


CREATE TABLE FILTROCONSULTAUSUARIO (
       IDEFILTROCONSULTA    NUMBER(10) NOT NULL,
       IDEUSUARIO           NUMBER(10) NOT NULL
);

CREATE INDEX XIF1FILTROCONSULTAUSUARIO ON FILTROCONSULTAUSUARIO
(
       IDEFILTROCONSULTA              ASC
);

CREATE INDEX XIF2FILTROCONSULTAUSUARIO ON FILTROCONSULTAUSUARIO
(
       IDEUSUARIO                     ASC
);


ALTER TABLE FILTROCONSULTAUSUARIO
       ADD  ( PRIMARY KEY (IDEFILTROCONSULTA, IDEUSUARIO) ) ;


CREATE TABLE FUNCIONALIDADESISTEMA (
       IDEFUNCIONALIDADESISTEMA NUMBER(10) NOT NULL,
       NOMFUNCIONALIDADESISTEMA VARCHAR2(255 BYTE) NOT NULL,
       DESFUNCIONALIDADESISTEMA VARCHAR2(255 BYTE) NOT NULL,
       NOMOBJETOCONTROLADO  VARCHAR2(255 BYTE) NOT NULL,
       IDEFUNCIONALIDADEAGRUPADORA NUMBER(10) NULL,
       IDESISTEMA           NUMBER(10) NOT NULL
);

CREATE UNIQUE INDEX UKFUNSIS_IDENOMCON ON FUNCIONALIDADESISTEMA
(
       IDESISTEMA                     ASC,
       NOMOBJETOCONTROLADO            ASC
);


ALTER TABLE FUNCIONALIDADESISTEMA
       ADD  ( PRIMARY KEY (IDEFUNCIONALIDADESISTEMA) ) ;


CREATE TABLE GESTORSISTEMA (
       IDESISTEMA           NUMBER(10) NOT NULL,
       IDEUSUARIO           NUMBER(10) NOT NULL,
       INDADMINISTRADOR     CHAR(1 BYTE) NOT NULL
                                   CHECK ( indadministrador in ('S','N'))
);


ALTER TABLE GESTORSISTEMA
       ADD  ( PRIMARY KEY (IDESISTEMA, IDEUSUARIO) ) ;


CREATE TABLE GRUPO (
       CODGRUPO             NUMBER(10) NOT NULL,
       DESGRUPO             VARCHAR2(255 BYTE) NOT NULL
);


ALTER TABLE GRUPO
       ADD  ( PRIMARY KEY (CODGRUPO) ) ;


CREATE TABLE GRUPOCATEGORIATALENTO (
       CODGRUPO             NUMBER(10) NOT NULL,
       IDECATEGORIA         NUMBER(10) NOT NULL
);

CREATE INDEX IXGRUPOCATEGTAL_CODGRUPO ON GRUPOCATEGORIATALENTO
(
       CODGRUPO                       ASC
);

CREATE INDEX IXGRUPOCATEGTAL_IDECATEGORIA ON GRUPOCATEGORIATALENTO
(
       IDECATEGORIA                   ASC
);


ALTER TABLE GRUPOCATEGORIATALENTO
       ADD  ( PRIMARY KEY (CODGRUPO, IDECATEGORIA) ) ;


CREATE TABLE GRUPOCRITERIOCONSULTA (
       IDEFILTROCONSULTA    NUMBER(10) NOT NULL,
       CODGRUPO             NUMBER(10) NOT NULL
);

CREATE INDEX XIF1GRUPOCRITERIOCONSULTA ON GRUPOCRITERIOCONSULTA
(
       IDEFILTROCONSULTA              ASC
);

CREATE INDEX XIF2GRUPOCRITERIOCONSULTA ON GRUPOCRITERIOCONSULTA
(
       CODGRUPO                       ASC
);


ALTER TABLE GRUPOCRITERIOCONSULTA
       ADD  ( PRIMARY KEY (IDEFILTROCONSULTA, CODGRUPO) ) ;


CREATE TABLE PERFILFUNCIONALIDADESISTEMA (
       IDEPERFILSISTEMA     NUMBER(10) NOT NULL,
       IDEFUNCIONALIDADESISTEMA NUMBER(10) NOT NULL
);


ALTER TABLE PERFILFUNCIONALIDADESISTEMA
       ADD  ( PRIMARY KEY (IDEPERFILSISTEMA, IDEFUNCIONALIDADESISTEMA) ) ;


CREATE TABLE PERFILSISTEMA (
       IDEPERFILSISTEMA     NUMBER(10) NOT NULL,
       NOMPERFILSISTEMA     VARCHAR2(255 BYTE) NOT NULL,
       DESPERFILSISTEMA     VARCHAR2(255 BYTE) NOT NULL,
       IDESISTEMA           NUMBER(10) NOT NULL,
       IDEPERFILAGRUPADOR   NUMBER(10) NULL,
       NOMOBJETOCONTROLADO  VARCHAR2(255 BYTE) NOT NULL
);


ALTER TABLE PERFILSISTEMA
       ADD  ( PRIMARY KEY (IDEPERFILSISTEMA) ) ;


CREATE TABLE PERFILSISTEMAGRUPO (
       IDEPERFILSISTEMA     NUMBER(10) NOT NULL,
       CODGRUPO             NUMBER(10) NOT NULL
);


ALTER TABLE PERFILSISTEMAGRUPO
       ADD  ( PRIMARY KEY (IDEPERFILSISTEMA, CODGRUPO) ) ;


CREATE TABLE SIGESPPESSOAL (
       IDEPESSOAL           NUMBER(10) NOT NULL,
       NOMPESSOAL           VARCHAR2(255 BYTE) NOT NULL,
       DATNASCIMENTO        DATE NOT NULL,
       INDSEXO              CHAR(1 BYTE) DEFAULT 'M' NOT NULL
                                   CHECK (indSexo in ('M', 'F')),
       NUMCPF               CHAR(11 BYTE) NULL,
       NUMRG                VARCHAR2(255 BYTE) NULL,
       CODGRUPO             NUMBER(10) NOT NULL
);

CREATE INDEX XIF1SIGESPPESSOAL ON SIGESPPESSOAL
(
       CODGRUPO                       ASC
);

CREATE INDEX IXSIGESPPESSOAL_NOMPESSOAL ON SIGESPPESSOAL
(
       NOMPESSOAL                     ASC
);


ALTER TABLE SIGESPPESSOAL
       ADD  ( PRIMARY KEY (IDEPESSOAL) ) ;


CREATE TABLE SIGESPPESSOALLOTACAO (
       IDEPESSOALLOTACAO    NUMBER(10) NOT NULL,
       IDEPESSOAL           NUMBER(10) NOT NULL,
       CODLOTACAO           NUMBER(10) NOT NULL,
       DESLOTACAO           VARCHAR2(255 BYTE) NOT NULL,
       DATINICIO            DATE NOT NULL,
       DATTERMINO           DATE NULL
);

CREATE INDEX IXSIGESPPESLOT_IDEPESSOAL ON SIGESPPESSOALLOTACAO
(
       IDEPESSOAL                     ASC
);


ALTER TABLE SIGESPPESSOALLOTACAO
       ADD  ( PRIMARY KEY (IDEPESSOALLOTACAO) ) ;


CREATE TABLE SISTEMA (
       IDESISTEMA           NUMBER(10) NOT NULL,
       NOMSISTEMA           VARCHAR2(255 BYTE) NOT NULL,
       DESSISTEMA           VARCHAR2(255 BYTE) NOT NULL,
       IDESISTEMAAGRUPADOR  NUMBER(10) NULL,
       NOMOBJETOCONTROLADO  VARCHAR2(255 BYTE) NOT NULL
);


ALTER TABLE SISTEMA
       ADD  ( PRIMARY KEY (IDESISTEMA) ) ;


CREATE TABLE TABELAAPOIOMM (
       IDETABELAAPOIOMM     NUMBER(10) NOT NULL,
       IDETABELAAPOIOMESTREMM NUMBER(10) NULL,
       NOMIDENTIFICADORTABELAAPOIO VARCHAR2(255 BYTE) NOT NULL,
       NOMDESCRITORTABELAAPOIO VARCHAR2(255 BYTE) NOT NULL,
       NOMIDENTIFICADORTABELAMESTRE VARCHAR2(255 BYTE) NULL,
       NOMTABELAAPOIOMM     VARCHAR2(255 BYTE) NOT NULL
);

CREATE UNIQUE INDEX UKTABAPOMM_NOMTABAPOMM ON TABELAAPOIOMM
(
       NOMTABELAAPOIOMM               ASC
);

CREATE INDEX IXTABAPOIOMM_IDETABAPOIOMESTMM ON TABELAAPOIOMM
(
       IDETABELAAPOIOMESTREMM         ASC
);


ALTER TABLE TABELAAPOIOMM
       ADD  ( PRIMARY KEY (IDETABELAAPOIOMM) ) ;


CREATE TABLE TALENTO (
       IDETALENTO           NUMBER(10) NOT NULL,
       IDECATEGORIA         NUMBER(10) NOT NULL,
       IDEPESSOAL           NUMBER(10) NOT NULL,
       DATLANCAMENTO        DATE NOT NULL
);

CREATE INDEX IXTALENTO_IDEPESSOAL ON TALENTO
(
       IDEPESSOAL                     ASC
);

CREATE INDEX IXTALENTO_IDECATEGORIA ON TALENTO
(
       IDECATEGORIA                   ASC
);


ALTER TABLE TALENTO
       ADD  ( PRIMARY KEY (IDETALENTO) ) ;


CREATE TABLE TIPOFILTROCONSULTA (
       IDETIPOFILTROCONSULTA NUMBER(10) NOT NULL,
       NOMTIPOFILTROCONSULTA VARCHAR2(255) NULL,
       NOMOBJETOCONTROLADO  VARCHAR2(255) NULL
);


ALTER TABLE TIPOFILTROCONSULTA
       ADD  ( PRIMARY KEY (IDETIPOFILTROCONSULTA) ) ;


CREATE TABLE TIPOHTML (
       IDETIPOHTML          INTEGER NOT NULL,
       DESTIPOHTML          VARCHAR2(255 BYTE) NOT NULL,
       INDMULTIPLICIDADE    CHAR(1 BYTE) DEFAULT NULL NOT NULL
                                   CHECK ( indMultiplicidade in ( 'L', 'U', 'M' ))
);

CREATE UNIQUE INDEX UKTIPOHTML_DESTIPOHTML ON TIPOHTML
(
       DESTIPOHTML                    ASC
);


ALTER TABLE TIPOHTML
       ADD  ( PRIMARY KEY (IDETIPOHTML) ) ;


CREATE TABLE USUARIOPERFILSISTEMA (
       IDEUSUARIO           NUMBER(10) NOT NULL,
       IDEPERFILSISTEMA     NUMBER(10) NOT NULL,
       INDGESTORPERFIL      CHAR(1 BYTE) NOT NULL
                                   CHECK (indgestorperfil in  ('S','N'))
);


ALTER TABLE USUARIOPERFILSISTEMA
       ADD  ( PRIMARY KEY (IDEUSUARIO, IDEPERFILSISTEMA) ) ;


CREATE TABLE USUARIOSISTEMA (
       IDEUSUARIO           NUMBER(10) NOT NULL,
       NOMUSUARIO           VARCHAR2(255 BYTE) NOT NULL,
       DESLOGIN             VARCHAR2(255 BYTE) NOT NULL,
       NUMSENHAHASH         VARCHAR2(255 BYTE) NOT NULL,
       INDEXPIRACAOSENHA    CHAR(1 BYTE) NOT NULL,
       DATATUALIZACAOSENHA  DATE NOT NULL,
       DATVALIDADE          DATE NULL,
       DATDESLIGAMENTO      DATE NULL,
       CODGRUPO             NUMBER(10) NULL
);

CREATE INDEX IXUSUARIOSISTEMA_CODGRPDESLOG ON USUARIOSISTEMA
(
       CODGRUPO                       ASC,
       DESLOGIN                       ASC
);


ALTER TABLE USUARIOSISTEMA
       ADD  ( PRIMARY KEY (IDEUSUARIO) ) ;


ALTER TABLE ATRIBUTOTALENTO
       ADD  ( FOREIGN KEY (IDETABELAAPOIOMM)
                             REFERENCES TABELAAPOIOMM ) ;


ALTER TABLE ATRIBUTOTALENTO
       ADD  ( FOREIGN KEY (IDEATRIBUTOPAI)
                             REFERENCES ATRIBUTOTALENTO ) ;


ALTER TABLE ATRIBUTOTALENTO
       ADD  ( FOREIGN KEY (IDETIPOHTML)
                             REFERENCES TIPOHTML ) ;


ALTER TABLE ATRIBUTOTALENTOOPCAO
       ADD  ( FOREIGN KEY (IDEATRIBUTOOPCAOPAI)
                             REFERENCES ATRIBUTOTALENTOOPCAO ) ;


ALTER TABLE ATRIBUTOTALENTOOPCAO
       ADD  ( FOREIGN KEY (IDEATRIBUTO)
                             REFERENCES ATRIBUTOTALENTO ) ;


ALTER TABLE ATRIBUTOTALENTOVALORADO
       ADD  ( FOREIGN KEY (IDECATEGORIAATRIBUTO)
                             REFERENCES CATEGORIAATRIBUTOTALENTO ) ;


ALTER TABLE ATRIBUTOTALENTOVALORADO
       ADD  ( FOREIGN KEY (IDEATRIBUTOOPCAO)
                             REFERENCES ATRIBUTOTALENTOOPCAO ) ;


ALTER TABLE ATRIBUTOTALENTOVALORADO
       ADD  ( FOREIGN KEY (IDETALENTO)
                             REFERENCES TALENTO ) ;


ALTER TABLE CATEGORIAATRIBUTOTALENTO
       ADD  ( FOREIGN KEY (IDECATEGORIA)
                             REFERENCES CATEGORIATALENTO ) ;


ALTER TABLE CATEGORIAATRIBUTOTALENTO
       ADD  ( FOREIGN KEY (IDEATRIBUTO)
                             REFERENCES ATRIBUTOTALENTO ) ;


ALTER TABLE FILTROCONSULTA
       ADD  ( FOREIGN KEY (IDETIPOFILTROCONSULTA)
                             REFERENCES TIPOFILTROCONSULTA
                             ON DELETE SET NULL ) ;


ALTER TABLE FILTROCONSULTAGRUPO
       ADD  ( FOREIGN KEY (CODGRUPO)
                             REFERENCES GRUPO ) ;


ALTER TABLE FILTROCONSULTAGRUPO
       ADD  ( FOREIGN KEY (IDEFILTROCONSULTA)
                             REFERENCES FILTROCONSULTA ) ;


ALTER TABLE FILTROCONSULTAUSUARIO
       ADD  ( FOREIGN KEY (IDEUSUARIO)
                             REFERENCES USUARIOSISTEMA ) ;


ALTER TABLE FILTROCONSULTAUSUARIO
       ADD  ( FOREIGN KEY (IDEFILTROCONSULTA)
                             REFERENCES FILTROCONSULTA ) ;


ALTER TABLE FUNCIONALIDADESISTEMA
       ADD  ( FOREIGN KEY (IDESISTEMA)
                             REFERENCES SISTEMA ) ;


ALTER TABLE FUNCIONALIDADESISTEMA
       ADD  ( FOREIGN KEY (IDEFUNCIONALIDADEAGRUPADORA)
                             REFERENCES FUNCIONALIDADESISTEMA ) ;


ALTER TABLE GESTORSISTEMA
       ADD  ( FOREIGN KEY (IDEUSUARIO)
                             REFERENCES USUARIOSISTEMA ) ;


ALTER TABLE GESTORSISTEMA
       ADD  ( FOREIGN KEY (IDESISTEMA)
                             REFERENCES SISTEMA ) ;


ALTER TABLE GRUPOCATEGORIATALENTO
       ADD  ( FOREIGN KEY (IDECATEGORIA)
                             REFERENCES CATEGORIATALENTO ) ;


ALTER TABLE GRUPOCATEGORIATALENTO
       ADD  ( FOREIGN KEY (CODGRUPO)
                             REFERENCES GRUPO ) ;


ALTER TABLE GRUPOCRITERIOCONSULTA
       ADD  ( FOREIGN KEY (CODGRUPO)
                             REFERENCES GRUPO ) ;


ALTER TABLE GRUPOCRITERIOCONSULTA
       ADD  ( FOREIGN KEY (IDEFILTROCONSULTA)
                             REFERENCES FILTROCONSULTA ) ;


ALTER TABLE PERFILFUNCIONALIDADESISTEMA
       ADD  ( FOREIGN KEY (IDEPERFILSISTEMA)
                             REFERENCES PERFILSISTEMA ) ;


ALTER TABLE PERFILFUNCIONALIDADESISTEMA
       ADD  ( FOREIGN KEY (IDEFUNCIONALIDADESISTEMA)
                             REFERENCES FUNCIONALIDADESISTEMA ) ;


ALTER TABLE PERFILSISTEMA
       ADD  ( FOREIGN KEY (IDESISTEMA)
                             REFERENCES SISTEMA ) ;


ALTER TABLE PERFILSISTEMA
       ADD  ( FOREIGN KEY (IDEPERFILAGRUPADOR)
                             REFERENCES PERFILSISTEMA ) ;


ALTER TABLE PERFILSISTEMAGRUPO
       ADD  ( FOREIGN KEY (IDEPERFILSISTEMA)
                             REFERENCES PERFILSISTEMA ) ;


ALTER TABLE PERFILSISTEMAGRUPO
       ADD  ( FOREIGN KEY (CODGRUPO)
                             REFERENCES GRUPO ) ;


ALTER TABLE SIGESPPESSOAL
       ADD  ( FOREIGN KEY (CODGRUPO)
                             REFERENCES GRUPO ) ;


ALTER TABLE SIGESPPESSOALLOTACAO
       ADD  ( FOREIGN KEY (IDEPESSOAL)
                             REFERENCES SIGESPPESSOAL ) ;


ALTER TABLE SISTEMA
       ADD  ( FOREIGN KEY (IDESISTEMAAGRUPADOR)
                             REFERENCES SISTEMA ) ;


ALTER TABLE TABELAAPOIOMM
       ADD  ( FOREIGN KEY (IDETABELAAPOIOMESTREMM)
                             REFERENCES TABELAAPOIOMM ) ;


ALTER TABLE TALENTO
       ADD  ( FOREIGN KEY (IDECATEGORIA)
                             REFERENCES CATEGORIATALENTO ) ;


ALTER TABLE TALENTO
       ADD  ( FOREIGN KEY (IDEPESSOAL)
                             REFERENCES SIGESPPESSOAL ) ;


ALTER TABLE USUARIOPERFILSISTEMA
       ADD  ( FOREIGN KEY (IDEUSUARIO)
                             REFERENCES USUARIOSISTEMA ) ;


ALTER TABLE USUARIOPERFILSISTEMA
       ADD  ( FOREIGN KEY (IDEPERFILSISTEMA)
                             REFERENCES PERFILSISTEMA ) ;


ALTER TABLE USUARIOSISTEMA
       ADD  ( FOREIGN KEY (CODGRUPO)
                             REFERENCES GRUPO ) ;



