<%@ page language="java" %>
<%@ taglib prefix="bean"      uri="http://struts.apache.org/tags-bean"    %>
<%@ taglib prefix="html"      uri="http://struts.apache.org/tags-html"    %>
<%@ taglib prefix="logic"     uri="http://struts.apache.org/tags-logic"   %>
<%@ taglib prefix="display"   uri="http://br.gov.camara.sigesp.biblioteca.displaytag" %>
<%@ taglib prefix="aa"        uri="http://ajaxanywhere.sourceforge.net/" %>
<%@ taglib prefix="c"         uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="joda" uri="http://www.joda.org/joda/time/tags"%>

<html:form action="/avisarJavaScriptResultadoConsultaTalento">
	<logic:present name="lstConsultaTalentos">
	        <table class="listagem">
	            <tr class="tituloTabelaListagem">
	                <td class="tituloTabelaListagem" width="90%">
	                    Resultado da consulta
	                </td>
	                <c:if test="${!empty sessionScope.lstConsultaTalentos}">
	                    <td class="tableCellHeaderButton">
	                        <a href="#" onclick="submeterForm();">Imprimir</a>
	                    </td>
                    </c:if>
	            </tr>
	            <tr class="displayTag">
	                <td colspan="2">
	                    <aa:zone name="aaListagem">
	                        <display:table name="sessionScope.lstConsultaTalentos" pagesize="20" requestURI="resultadoConsultaTalentoEfetuarConsulta.do" id="dtResultadoConsultaTalento" export="true" excludedParams="consultaTextual tipoConsulta categoriaTalento criterioConsulta" keepStatus="true">
	                            <display:column property="ponto" title="Ponto" href="../BancoTalentosGestao/curriculoPrepararVisualizacaoConsulta.do?ret=rescons" paramId="chave" paramProperty="ponto"  sortable="true" style="text-align: right; width: 10%"/>
	                            <display:column property="nome" title="Descrio" style="text-align: left;" href="../BancoTalentosGestao/curriculoPrepararVisualizacaoConsulta.do?ret=rescons" paramId="chave" paramProperty="ponto" sortable="true"/>
	                            <display:column property="codigoGrupo" title="Grupo" style="text-align: center; width: 8%" href="../BancoTalentosGestao/curriculoPrepararVisualizacaoConsulta.do?ret=rescons" paramId="chave" paramProperty="ponto" sortable="true" />
                                <display:column title="Desligamento" style="text-align: center; width: 14%" property="dataDesligamentoComoData" href="../BancoTalentosGestao/curriculoPrepararVisualizacaoConsulta.do?ret=rescons" paramId="chave" paramProperty="ponto" sortable="true" format="{0,date,dd/MM/yyyy}" />
                                <display:column title="ltima atualizao" style="text-align: center; width: 14%" property="dataHoraUltimaAtualizacaoCurricularComoData" href="../BancoTalentosGestao/curriculoPrepararVisualizacaoConsulta.do?ret=rescons" paramId="chave" paramProperty="ponto" sortable="true" format="{0,date,dd/MM/yyyy}" />
		                        <display:column title="Imprimir<input type='checkbox' name='checkUncked' style='margin: 1 1 1 1' onclick='checkUnckeAll();' />" style="text-align: center; width: 5%" media="html">
		                            <bean:define id="intIdentificador" type="java.lang.Integer" name="dtResultadoConsultaTalento" property="ponto" />
		                            <input type="checkbox" name="idePessoa" value="<%=intIdentificador%>" style='margin: 1 1 1 1'/>
		                        </display:column>
	                        </display:table>
	                    </aa:zone>
	                    <script language="javascript">
	                        configurarAADisplayTag('aaListagem');
	                    </script>
	                </td>
	            </tr>
	        </table>
		    <logic:equal name="lstConsultaTalentos" value="null">
		        <center>
		            <h3>
		                Sua consulta no retornou resultados.
		            </h3>
		        </center>
		    </logic:equal>
	</logic:present>
</html:form>

<logic:notPresent name="lstConsultaTalentos">
	<logic:present name="stbTotalRegistros">
    	<center>
			<br>
			<h3>
				Sua consulta retornou mais resultados (<bean:write name="stbTotalRegistros"/>) que o permitido (<%= br.gov.camara.util.aplicacao.AplicacaoPlugIn.obterConfiguracao("MAXIMO_REGISTROS_CONSULTA_TALENTOS") %>).<br/>
				Refine sua pesquisa e tente novamente.
			</h3>
	    </center>
	</logic:present>
    <logic:notPresent name="stbTotalRegistros">
        <center>
            <br>
            <h3>
                Sua consulta retornou mais resultados que o permitido (<%= br.gov.camara.util.aplicacao.AplicacaoPlugIn.obterConfiguracao("MAXIMO_REGISTROS_CONSULTA_TALENTOS") %>).<br/>
                Refine sua pesquisa e tente novamente.
            </h3>
        </center>
    </logic:notPresent>
</logic:notPresent>

<p class="voltar">
    <input type="button" onclick="javascript:avisarProcessamento(); direcionarURL('consultaTalentoPrepararVisualizacao.do?limpar=true');" value='<bean:message key="sigesp.comum.interface.operacao.novaconsulta" bundle="comum"/>'>
    &nbsp;&nbsp;
    <input type="button" onclick="javascript:avisarProcessamento(); direcionarURL('consultaTalentoPrepararVisualizacao.do?limpar=false&ret=rescons');" value='<bean:message key="sigesp.comum.interface.operacao.editarconsulta" bundle="comum"/>'>
</p>

<script>

    function checkUnckeAll()
    {
        //  necessrio habilitar o primeiro campo no caso de no haver mais de um registro/checkbox, ou seja
        // havendo um checkbox no ser feito um array de ideFuncionalidadeSistema
        document.forms[0].idePessoa.checked = document.forms[0].checkUncked.checked;
        for (i = 0; i < document.forms[0].idePessoa.length; i++) {
            document.forms[0].idePessoa[i].checked = document.forms[0].checkUncked.checked;
        }
    }

    function submeterForm()
    {
        avisarProcessamento(true);
        var existeSelecao = false;
        var idCurriculoSelecionado = '';
        for (i = 0; i < document.forms[0].idePessoa.length; i++) 
        {
            if (document.forms[0].idePessoa[i].checked == true)
            {
                existeSelecao = true;
                idCurriculoSelecionado += document.forms[0].idePessoa[i].value + ','; 
            }
        }

        if (!existeSelecao)
        {
            alert('Selecione pelo menos um currculo para gerar o arquivo PDF');
        }
        else
        {
	        openPopUp('resultadoConsultaTalentoGerarRelatorio.do?curriculos=' + idCurriculoSelecionado, '', 600, 400, 10, 10, true);
        }
        avisarProcessamento(false); 
        return existeSelecao;
    }
    
</script>
