/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.hibernate;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.gov.camara.BaseTestesTestCase;
import br.gov.camara.negocio.exception.DAOException;

public class HibernateUtilTest extends BaseTestesTestCase
{
    /**
     * Logger for this class
     */
    private static final Log log = LogFactory.getLog(HibernateUtilTest.class.getName());

    /**
     * O mtodo inicializar com um parmetro String utiliza as configuraes da conexo
     * contidas no arquivo informado. A especificao da localizao do arquivo deve ser
     * relativa a um caminho que est no classpath.
     */
    public void testInicializarString() throws Exception
    {
        log.info(MENSAGEM_INICIO_TESTE);
        // Este mtodo no precisa ser testado, pois a inicializao  feita antes de executar
        // qualquer mtodo de teste.
    }

    /**
     * Verifica se o nome do dialeto recuperado est de acordo com 
     * aquele especificado no arquivo de configurao para a conexo especificada.
     */
    public void testObterDialeto()
    {
        log.info(MENSAGEM_INICIO_TESTE);
        assertEquals("org.hibernate.dialect.H2Dialect", HibernateUtilCD.obterDialeto(null));
    }

    /**
     * Verifica, atravs da chamada para obter a formatao do campo data, se o dialeto
     * em questo est sendo tratado pelo DAO
     */
    public void testIsDialetoTrado() throws DAOException
    {
        log.info(MENSAGEM_INICIO_TESTE);
        H2DAO h2dao = new H2DAO();
        assertTrue(h2dao.isDialetoTratado());
    }

    /**
     * O nome da conexo padro  o nome do primeiro alias especificado 
     * no arquivo de configurao.
     */
    public void testObterNomeConexaoPadrao()
    {
        log.info(MENSAGEM_INICIO_TESTE);
        assertEquals("conexaoPadrao", HibernateUtilCD.obterNomeConexaoPadrao());
    }
}
