/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.seguranca;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.gov.camara.BaseTestesTestCase;
import br.gov.camara.exception.CDException;
import br.gov.camara.seguranca.UnidadeAutenticadora;
import br.gov.camara.seguranca.exception.SegurancaException;
import br.gov.camara.seguranca.implementacaobt.UnidadeAutenticadoraBT;
import br.gov.camara.seguranca.util.SegurancaUtil;
import br.gov.camara.testes.base.BaseFacadeTestCase;

abstract class BaseAutenticacaoTestCase extends BaseTestesTestCase
{
    /**
    * Logger for this class
    */
    private static final Log log = LogFactory.getLog(BaseAutenticacaoTestCase.class.getName());

    UnidadeAutenticadora unidadeAutenticadora = null;

    @Override
    protected void executarAntesDeChamarMetodo() throws CDException
    {
        super.executarAntesDeChamarMetodo();

        SegurancaUtil segurancaUtil = new SegurancaUtil();

        unidadeAutenticadora = segurancaUtil.obterInstanciaUnidadeAutenticadora();
        if (!(unidadeAutenticadora instanceof UnidadeAutenticadoraBT))
        {
            SegurancaException.dispararExcecao("A unidade autenticadora especificada no  uma instncia da UnidadeAutenticadoraBT");
        }
    }

    @Override
    protected void executarDepoisDeChamarMetodo() throws CDException
    {
        super.executarDepoisDeChamarMetodo();
    }

}
