/****
 * Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Cmara dos Deputados, Brasil
 * 
 * Este arquivo  parte do programa TALENTOS - Banco de Talentos
 *
 * O TALENTOS  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt", junto com este programa, se no, escreva para a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ***/

package br.gov.camara.testes.base;

import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;

import br.gov.camara.exception.CDException;
import br.gov.camara.hibernate.HibernateUtilCD;

public abstract class BaseFacadeTestCase extends BaseNegocioTestCase
{
    private static HibernateUtilCD hibernateUtilCD = null;
    private static boolean blnAmbientePreparado = false;

    protected void inicializarHibernate(String strNomeArquivoConfiguracaoHibernate) throws CDException
    {
        if (hibernateUtilCD != null)
        {
            return;
        }

        if (!blnAmbientePreparado)
        {
            throw new RuntimeException("O ambiente ainda no foi configurado");
        }

        hibernateUtilCD = new HibernateUtilCD();
        hibernateUtilCD.inicializar(strNomeArquivoConfiguracaoHibernate);
    }

    protected static void finalizarHibernate() throws CDException
    {
        if (hibernateUtilCD != null)
        {
            hibernateUtilCD.finalizar();
            hibernateUtilCD = null;
        }
    }

    @Override
    protected void configurarAmbiente()
    {
        super.configurarAmbiente();

        // Seta as propriedades necessrias para o hibernate-config
        System.setProperty("org.xml.sax.driver", "org.apache.crimson.parser.XMLReaderImpl");
        System.setProperty("delimitadoraSessaoTransacaoImpl", "br.gov.camara.hibernate.TestCaseDelimitadora");

        blnAmbientePreparado = true;
    }

    private static void prepararHibernate()
    {
        // Adicionar caminho dos arquivos MODULO-hibernate.xml do projeto web no classpath
        try
        {
            File file = new File(""); // Caminho RAIZ do PROJETO

            StringBuffer caminhoArquivosModuloHibernateXml = new StringBuffer();
            // Caminho raiz do projeto
            caminhoArquivosModuloHibernateXml.append(file.getAbsolutePath().replaceAll("\\\\", "/"));
            caminhoArquivosModuloHibernateXml.append("/");
            // Caminho para os arquivos do mdulo web
            // caminhoArquivosModuloHibernateXml.append("web"); // => estrutura antiga
            caminhoArquivosModuloHibernateXml.append("src/main/webapp"); // estrutura maven
            caminhoArquivosModuloHibernateXml.append("/");
            // Diretrio com os arquivos de configurao dos mdulos
            caminhoArquivosModuloHibernateXml.append("/WEB-INF/config/");

            File fileProjetoWeb = new File(caminhoArquivosModuloHibernateXml.toString());
            if (fileProjetoWeb.exists())
            {
                ClassLoader cl = new URLClassLoader(new URL[] { new URL("file", "", fileProjetoWeb.getPath().replaceAll("\\\\", "/")
                        + "/") }, Thread.currentThread().getContextClassLoader());
                Thread.currentThread().setContextClassLoader(cl);
            }
        }
        catch (Exception mue)
        {
            // Pacincia, pois no deveria acontecer...
        }

        // Seta as propriedades necessrias para o hibernate-config
        System.setProperty("org.xml.sax.driver", "org.apache.crimson.parser.XMLReaderImpl");
        System.setProperty("delimitadoraSessaoTransacaoImpl", "br.gov.camara.hibernate.JUnitDelimitadora");

        blnAmbientePreparado = true;
    }
}
